if( typeof tiki_plugins == 'undefined' ) { var tiki_plugins = {}; }
tiki_plugins.addtocart = {"name":"Add to cart","documentation":"PluginAddToCart","description":"Adds a product to the virtual cart. The cart can be manipulated using the cart module.","prefs":["wikiplugin_addtocart","payment_feature"],"filter":"wikicontent","format":"html","params":{"code":{"required":true,"name":"Product code","description":"Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in.","filter":"text","default":""},"description":{"required":true,"name":"Description","description":"Label for the product in the cart.","filter":"text","default":""},"price":{"required":true,"name":"Price","description":"The price to charge for the item.","filter":"text","default":""},"href":{"required":false,"name":"Location","description":"URL of the product's information. The URL may be relative or absolute (begin with http:\/\/).","filter":"url","default":""},"label":{"required":false,"name":"Button label","description":"Text for the submit button. default: \"Add to cart\"","filter":"text","default":"Add to cart"}}};
tiki_plugins.addtogooglecal = {"name":"Add Event to Google Calendar","documentation":"PluginAddToGoogleCal","description":"Creates an icon for a user to add an event to a Google Calendar","prefs":["wikiplugin_addtogooglecal"],"introduced":6,"params":{"calitemid":{"required":true,"name":"Calendar item ID","description":"The item ID of the calendar to add to Google calendar.","accepted":"A calendar item ID number","filter":"digits","default":"","since":"6.0"},"iconstyle":{"required":false,"name":"Icon Style","description":"Choose the icon style","accepted":"Either 1, 2 or 3","filter":"digits","default":1,"since":"6.0","options":[{"text":"","value":""},{"text":"One","value":1},{"text":"Two","value":2},{"text":"Three","value":3}]}}};
tiki_plugins.agentinfo = {"name":"User Agent Info","documentation":"PluginAgentinfo","description":"Displays various information about the client.","prefs":["wikiplugin_agentinfo"],"params":{"info":{"required":false,"name":"Info","description":"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW).","default":"IP","filter":"alpha","options":[{"text":"","value":""},{"text":"IP address","value":"IP"},{"text":"Server software","value":"SVRSW"},{"text":"Browser","value":"BROWSER"}]}}};
tiki_plugins.alink = {"name":"Anchor Link","documentation":"PluginAlink","description":"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin.","prefs":["wikiplugin_alink"],"body":"Anchor link label.","icon":"pics\/icons\/world_link.png","params":{"aname":{"required":true,"name":"Anchor Name","description":"The anchor name as defined in the ANAME plugin.","default":""},"pagename":{"required":false,"name":"Page Name","description":"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used.","filter":"pagename","default":""}}};
tiki_plugins.aname = {"name":"Anchor Name","documentation":"PluginAname","description":"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin.","prefs":["wikiplugin_aname"],"body":"The name of the anchor.","params":[],"icon":"pics\/icons\/anchor.png"};
tiki_plugins.annotation = {"name":"Image Annotation","documentation":"PluginAnnotation","description":"Displays an image and enables users to define zones to highlight information on the image.","prefs":["wikiplugin_annotation"],"body":"Autogenerated content. Leave blank initially.","filter":"striptags","params":{"src":{"required":true,"name":"Location","description":"Absolute URL to the image or relative path from tiki root.","filter":"url","default":""},"width":{"required":true,"name":"Width","description":"Image width in pixels.","filter":"digits","default":""},"height":{"required":true,"name":"Height","description":"Image height in pixels.","filter":"digits","default":""},"align":{"required":false,"name":"Alignment","description":"Image alignment. Possible values: left, right, center. Default is left","filter":"alpha","advanced":true,"default":"left","options":[{"text":"","value":""},{"text":"Left","value":"left"},{"text":"Right","value":"right"},{"text":"Center","value":"center"}]}}};
tiki_plugins.archivebuilder = {"name":"Archive Builder","documentation":"PluginArchiveBuilder","description":"Builds a zip archive containing the specified data from tikiwiki.","prefs":["wikiplugin_archivebuilder"],"body":"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder\/foo.pdf:HomePage , tracker-attachments:target-folder\/:3435","params":{"name":{"name":"Archive Name","description":"Upon download, the name of the file that will be provided.","required":true,"default":""}}};
tiki_plugins.article = {"name":"Article","documentation":"PluginArticle","description":"Includes an article's content within the page.","prefs":["feature_articles","wikiplugin_article"],"params":{"Field":{"required":false,"name":"Field","description":"The article field to display. Default field is Heading.","filter":"word","default":"heading"},"Id":{"required":false,"name":"Article ID","description":"The article to display. If no value is provided, most recent article will be used.","filter":"digits","default":""}}};
tiki_plugins.articles = {"name":"Article List","documentation":"PluginArticles","description":"Inserts a list of articles in the page.","prefs":["feature_articles","wikiplugin_articles"],"params":{"usePagination":{"required":false,"name":"Use Pagination","description":"Activate pagination when articles listing are long. Default is n","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"max":{"required":false,"name":"Maximum Displayed","description":"The number of articles to display in the list (no max set by default)If Pagination is set to y (Yes), this will determine the amount of artilces per page","filter":"int","default":-1},"topic":{"required":false,"name":"Topic Name Filter","description":"Filter the list of aricles by their topic. Example: [!]topic+topic+topic","filter":"striptags","default":""},"topicId":{"required":false,"name":"Topic ID Filter","description":"Filter the list of aricles by their topic ID. Example: [!]topicId+topicId+topicId","filter":"striptags","default":""},"type":{"required":false,"name":"Type Filter","description":"Filter the list of aricles by their types. Example: [!]type+type+type","filter":"striptags","default":""},"categId":{"required":false,"name":"Category ID","description":"The ID of the category that articles need to be in to be listed","filter":"digits","default":""},"lang":{"required":false,"name":"Language","description":"List only articles in this language","filter":"lang","default":""},"sort":{"required":false,"name":"Sort order","description":"The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\") Use random to have random items.","filter":"word","default":"publishDate_desc"},"quiet":{"required":false,"name":"Quiet","description":"Whether to not report when there are no articles (no reporting by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"titleonly":{"required":false,"name":"Title Only","description":"Whether to only show the title of the articles (not set to title only by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"fullbody":{"required":false,"name":"Body Only","description":"Whether to only show the body of the articles or just the heading and title. (not set to body only by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"start":{"required":false,"name":"Starting Article","description":"The article number that the list should start with (starts with first article by default)This will not work if Pagination is used.","filter":"int","default":0},"dateStart":{"required":false,"name":"Start Date","description":"Earliest date to select articles from. (YYYY-MM-DD)","filter":"date","default":""},"dateEnd":{"required":false,"name":"End date","description":"Latest date to select articles from. (YYYY-MM-DD)","filter":"date","default":""},"overrideDates":{"required":false,"name":"Override Dates","description":"Whether to obey article type's \"show before publish\" and \"show after expiry\" settings (not obeyed by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"containerClass":{"required":false,"name":"Container class","description":"CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")","filter":"striptags","default":"wikiplugin_articles"},"largefirstimage":{"required":false,"name":"Large First Image","description":"If set to y (Yes), the first image will be displayed with the dimension used to view of the article","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"urlparam":{"required":false,"name":"Additional URL Param to the link to read article","filter":"striptags","default":""},"actions":{"required":false,"name":"Show actions (buttons and links)","description":"Whether to show the buttons and links to do actions on each article (for the actions you have permission to do (y|n)","filter":"alpha"}}};
tiki_plugins.attach = {"name":"Attachment","documentation":"PluginAttach","description":"Displays an attachment or a list of them","prefs":["feature_wiki_attachments","wikiplugin_attach"],"body":"Comment","params":{"name":{"required":false,"name":"Name","description":"File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment","default":""},"file":{"required":false,"name":"File","description":"Same as name","default":""},"page":{"required":false,"name":"Page","description":"Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page.","default":""},"showdesc":{"required":false,"name":"Show Description","description":"Shows the description as the link text instead of the file name (not used by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"bullets":{"required":false,"name":"Bullets","description":"Makes the list of attachments a bulleted list (not set by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"image":{"required":false,"name":"Image","description":"Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"inline":{"required":false,"name":"Custom Label","description":"Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed.","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"all":{"required":false,"name":"All","description":"Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"num":{"required":false,"name":"Order Number","description":"Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment.","default":""},"id":{"required":false,"name":"ID","description":"Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment."},"dls":{"required":false,"name":"Downloads","description":"The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"icon":{"required":false,"name":"File Type Icon","description":"A file type icon is displayed in front of the attachment link when this is set to 1","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.attributes = {"name":"Attributes","documentation":"PluginAttributes","description":"Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes.","prefs":["wikiplugin_attributes"],"extraparams":true,"defaultfilter":"text","params":[]};
tiki_plugins.author = {"name":"Author","documentation":"PluginAuthor","description":"Color codes parts of the page like 'Track changes' in Office programs.","prefs":["wikiplugin_author"],"body":"text","params":{"author":{"required":true,"name":"User Name","description":"User name of the user who wrote the text.","default":"","filter":"username"},"deleted_by":{"required":false,"name":"Deleted by User","description":"User name of the user who deleted the text.","default":"","filter":"username"},"visible":{"required":false,"name":"Make Visible","description":"Should this author's contribution be visible (default: no).","filter":"text","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}]},"popup":{"required":false,"name":"Show popup with author\/deleted by","description":"Generate a popup with names of author(s) (default: no).","filter":"text","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}]}}};
tiki_plugins.avatar = {"name":"Avatar","documentation":"PluginAvatar","description":"Displays the user Avatar","prefs":["wikiplugin_avatar"],"body":"username","params":{"page":{"required":false,"name":"Page","description":"The wiki page the avatar will link to. If empty and the user's information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user's user information page","default":""},"float":{"required":false,"name":"Float","description":"Align the avatar on the page","filter":"word","options":[{"text":"","value":""},{"text":"Right","value":"right"},{"text":"Left","value":"left"}]}}};
tiki_plugins.back = {"name":"Back","documentation":"PluginBack","description":"Displays a link that goes back one page in the browser history","prefs":["wikiplugin_back"],"params":[]};
tiki_plugins.backlinks = {"name":"Backlinks","documentation":"PluginBacklinks","description":"List all pages linking to the specified page.","prefs":["feature_wiki","wikiplugin_backlinks"],"params":{"page":{"required":false,"name":"Page","description":"The page links will point to. Default value is the current page.","advanced":true,"default":"[pagename]"},"info":{"required":false,"name":"Displayed Information","description":"Pipe separated list of fields to display. ex: hits|user","advanced":true,"default":false},"exclude":{"required":false,"name":"Excluded pages","description":"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox","advanced":true,"default":""},"include_self":{"required":false,"name":"Include Self","description":"With or without self-link (default is without)","advanced":true,"default":0,"options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}]},"noheader":{"required":false,"name":"Header","description":"With or without header (default is with header)","options":[{"text":"","value":""},{"text":"With header","value":"0"},{"text":"Without header","value":"1"}]}}};
tiki_plugins.banner = {"name":"Banner","documentation":"PluginBanner","description":"Insert a banner","prefs":["wikiplugin_banner"],"params":{"zone":{"required":true,"name":"Zone","description":"Name of the zone created in Admin > Banners","default":""},"target":{"required":false,"name":"Target","description":"Determines the browser behavior once the banner is clicked","default":"","options":[{"text":"","value":""},{"text":"Blank","value":"_blank"},{"text":"Display","value":"display"}]}}};
tiki_plugins.bigbluebutton = {"name":"BigBlueButton","documentation":"PluginBigBlueButton","description":"Allows to join a BigBlueButton meeting.","format":"html","prefs":["wikiplugin_bigbluebutton","bigbluebutton_feature"],"params":{"name":{"required":true,"name":"Meeting","description":"MeetingID provided by BigBlueButton.","filter":"text","default":""},"prefix":{"required":false,"name":"Anonymous prefix","description":"Unregistered users will get this token prepended to their name.","filter":"text","default":""},"welcome":{"required":false,"name":"Welcome Message","description":"A message to be provided when someone enters the room.","filter":"text","default":""},"number":{"required":false,"name":"Dial Number","description":"The phone-in support number to join from traditional phones.","filter":"text","default":""},"voicebridge":{"required":false,"name":"Voice Bridge","description":"Code to enter for phone attendees to join the room.","filter":"digits","default":""},"logout":{"required":false,"name":"Logout URL","description":"URL to which the user will be redirected when logging out from BigBlueButton.","filter":"url","default":""},"max":{"required":false,"name":"Maximum Participants","description":"Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server.","filter":"int","default":""}}};
tiki_plugins.bliptv = {"name":"Bliptv","documentation":"PluginBliptv","description":"Display a Blip.tv video","prefs":["wikiplugin_bliptv"],"icon":"pics\/icons\/bliptv.png","params":{"url":{"required":true,"name":"URL","description":"Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http:\/\/blip.tv\/play\/AYGd_GAC (instead of http:\/\/blip.tv\/file\/2568201\/) ","filter":"url","default":""},"width":{"required":false,"name":"Width","description":"Width in pixels (default is 425","filter":"digits","default":425},"height":{"required":false,"name":"Height","description":"Height in pixels (default is 350)","filter":"digits","default":350}}};
tiki_plugins.bloglist = {"name":"Blog List","documentation":"PluginBlogList","description":"Use BLOGLIST to include posts from a blog.","prefs":["feature_blogs","wikiplugin_bloglist"],"params":{"Id":{"required":true,"name":"Blog ID","description":"The ID number of the blog on the site you wish to list posts from","filter":"digits","default":""},"Items":{"required":false,"name":"Maximum Items","description":"Maximum number of entries to list (no maximum set by default)","filter":"digits","default":""},"author":{"required":false,"name":"Author","description":"Only display posts created by this user (all posts listed by default)","default":""},"simpleList":{"required":false,"name":"Simple List","description":"Show simple list of date, title and author (default=y) or formatted list of blog posts (n)","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"dateStart":{"required":false,"name":"Start Date","description":"Earliest date to select posts from. (YYYY-MM-DD)","filter":"date","default":""},"dateEnd":{"required":false,"name":"End Date","description":"Latest date to select posts from. (YYYY-MM-DD)","filter":"date","default":""},"containerClass":{"required":false,"name":"Container Class","description":"CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")","filter":"striptags","default":"wikiplugin_bloglist"}}};
tiki_plugins.box = {"name":"Box","documentation":"PluginBox","description":"Insert theme-styled box on wiki page","prefs":["wikiplugin_box"],"body":"text","params":{"title":{"required":false,"name":"Box title","description":"Displayed above the content","default":""},"bg":{"required":false,"name":"Background color","description":"As defined by CSS, name or Hex code."},"width":{"required":false,"name":"Box width","description":"In pixels or percentage. Default value is 100%."},"align":{"required":false,"name":"Text Alignment","description":"Aligns the text within the box (left aligned by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Right","value":"right"},{"text":"Center","value":"center"}]},"float":{"required":false,"name":"Float Position","description":"Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Left","value":"left"},{"text":"Right","value":"right"}]},"clear":{"required":false,"name":"Clear","description":"Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)","filter":"text","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"class":{"required":false,"name":"CSS Class","description":"Apply custom CSS class to the box."},"id":{"required":false,"name":"ID","description":"ID"}}};
tiki_plugins.button = {"name":"Button","documentation":"PluginButton","description":"Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin","prefs":["wikiplugin_button"],"validate":"none","extraparams":false,"params":{"href":{"required":true,"name":"Url","description":"URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it","filter":"url","default":""},"_text":{"required":false,"name":"Label","description":"Label for the button","filter":"text","default":""}}};
tiki_plugins.calendar = {"name":"Calendar","documentation":"PluginCalendar","description":"Includes a calendar and\/or a list of calendar events.","prefs":["feature_calendar","wikiplugin_calendar"],"params":{"calIds":{"name":"Calendar IDs","description":"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\"). Example values:\"13\", \"4,7\", \"31,49\". Not set by default.","filter":"digits","separator":",","default":""},"viewlist":{"required":false,"name":"View Type","description":"Determines how to show events. Possible values: table, list, both. \"table\" shows events in a calendar. Default value: table.","filter":"word","default":"table","options":[{"text":"","value":""},{"text":"List","value":"list"},{"text":"Table","value":"table"},{"text":"Both","value":"both"}]},"viewmode":{"name":"View Time Span","description":"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: year, semester, quarter, month, week, day. Default is month","filter":"word","default":"month","options":[{"text":"","value":""},{"text":"Day","value":"day"},{"text":"Week","value":"week"},{"text":"Month","value":"month"},{"text":"Quarter","value":"quarter"},{"text":"Semester","value":"semester"},{"text":"Year","value":"year"}]},"viewnavbar":{"required":false,"name":"Navigation Bar","description":"Decide or not to show the navigation bar (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.category = {"name":"Category","documentation":"PluginCategory","description":"Insert list of items with the current\/given category in the wiki page","prefs":["feature_categories","wikiplugin_category"],"params":{"id":{"required":false,"name":"Category IDs","description":"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page.","filter":"digits","separator":"+","default":""},"types":{"required":false,"name":"Types","description":"List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br \/>+forum+igal+newsletter<br \/>+event+poll+quiz+survey<br \/>+tracker+wiki+img","filter":"text","default":"*"},"sort":{"required":false,"name":"Sort Order","description":"Sort ascending or descending based on various attributes (sorted ascending by name by default)","filter":"text","default":"","options":[{"text":"","value":""},{"text":"Created Ascending","value":"created_asc"},{"text":"Created Descending","value":"created_desc"},{"text":"Hits Ascending","value":"hits_asc"},{"text":"Hits Descending","value":"hits_desc"},{"text":"Item ID Ascending","value":"itemId_asc"},{"text":"Item ID Descending","value":"itemId_desc"},{"text":"Name Ascending","value":"name_asc"},{"text":"Name Descending","value":"name_desc"},{"text":"Type Ascending","value":"type_asc"},{"text":"Type Descending","value":"type_desc"},{"text":"Random","value":"random"}]},"split":{"required":false,"name":"Split","description":"Whether multiple categories will be listed on different lines (default is to split them)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"and":{"required":false,"name":"And","description":"If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"sub":{"required":false,"name":"With Sub-categories","description":"Also list objects in sub-categories of the categories given (default is to list sub-category objects)","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdescription":{"required":false,"name":"Show Description","description":"Show descriptions (not shown by default)","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showname":{"required":false,"name":"Show Name","description":"Show object names (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showtype":{"required":false,"name":"Show type","description":"Show type (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"one":{"required":false,"name":"One Per Line","description":"Show one object per line (multiple per line shown by default)","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlinks":{"required":false,"name":"Show Child Links","description":"Show children category links (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"categoryshowlink":{"required":false,"name":"Show Top Link","description":"Show top category link (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"maxRecords":{"required":false,"name":"Max Records","description":"Maximum number of objects to list (default is 50)","default":"50","filter":"digits"},"showTitle":{"required":false,"name":"Show Title","description":"Show title text above category object lists (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.catorphans = {"name":"Category Orphans","documentation":"PluginCatOrphans","description":"Display wiki pages that have not been categorized","prefs":["feature_categories","wikiplugin_catorphans"],"params":{"objects":{"required":false,"name":"Object","description":"Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)","default":"wiki","options":[{"text":"","value":""},{"text":"Wiki Pages","value":"wiki"}]},"max":{"required":false,"name":"Max","description":"Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records.","default":"$prefs['maxRecords']"},"offset":{"required":false,"name":"Result Offset","description":"Result number at which the listing should start (default is no offset)","default":0}}};
tiki_plugins.catpath = {"name":"Category Path","documentation":"PluginCatPath","description":"Insert the full category path for each category that this wiki page belongs to","prefs":["feature_categories","wikiplugin_catpath"],"params":{"divider":{"required":false,"name":"Separator","description":"String used to separate the categories in the path. Default character is >.","default":">"},"top":{"required":false,"name":"Display Top Category","description":"Show the top category as part of the path name (not shown by default)","filter":"alpha","default":"no","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.cclite = {"name":"Cclite","documentation":"PluginCclite","description":"General purpose cclite utility plugin","prefs":["wikiplugin_cclite","payment_feature"],"params":{"mode":{"required":false,"name":"Mode","description":"Mode of operation - summary or recent. Default: summary","filter":"text","default":"summary","options":[{"text":"","value":""},{"text":"Account summary","value":"summary"},{"text":"Recent transactions","value":"recent"}]},"registry":{"required":false,"name":"Registry","description":"Registry to query. Default: site preference (or first in list when more than one)","filter":"text","default":""}}};
tiki_plugins.center = {"name":"Center","documentation":"PluginCenter","description":"Centers the plugin content in the wiki page","prefs":["wikiplugin_center"],"body":"text","icon":"pics\/icons\/text_align_center.png","params":[]};
tiki_plugins.chart = {"name":"Chart","documentation":"PluginChart","description":"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool.","prefs":["feature_sheet","wikiplugin_chart"],"body":"Chart caption.","params":{"id":{"required":true,"name":"Sheet ID","description":"Data sheet ID"},"type":{"required":true,"name":"Chart Type","description":"BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic"},"width":{"required":true,"name":"Chart Width","description":"Width in pixels."},"height":{"required":true,"name":"Chart Height","description":"Height in pixels."},"value":{"required":false,"name":"Value series","description":"Required for pie charts"},"x":{"required":false,"name":"Independant series","description":"Required for types other than pie chart"},"y0":{"required":false,"name":"Dependant series","description":"Required for types other than pie chart"},"y1":{"required":false,"name":"Dependant series","description":""},"y2":{"required":false,"name":"Dependant series","description":""},"y3":{"required":false,"name":"Dependant series","description":""},"y4":{"required":false,"name":"Dependant series","description":""},"color":{"required":false,"name":"Colors","description":"List of colors to use."},"style":{"required":false,"name":"Styles","description":"List of styles to use."},"label":{"required":false,"name":"Labels","description":"Labels for the series or values in the legend."}}};
tiki_plugins.code = {"name":"Code","documentation":"PluginCode","description":"Displays a snippet of code","prefs":["wikiplugin_code"],"body":"Code","icon":"pics\/icons\/page_white_code.png","params":{"caption":{"required":false,"name":"Caption","description":"Code snippet label."},"wrap":{"required":false,"name":"Word Wrap","description":"Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}]},"colors":{"required":false,"name":"Colors","description":"Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus...","advanced":true},"ln":{"required":false,"name":"Line Numbers","description":"Show line numbers for each line of code. May not be used with colors unless GeSHI is installed.","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}],"advanced":true},"wiki":{"required":false,"name":"Wiki Syntax","description":"Parse wiki syntax within the code snippet (not parsed by default)","options":[{"text":"","value":""},{"text":"No","value":"0"},{"text":"Yes","value":"1"}],"advanced":true},"rtl":{"required":false,"name":"Right to Left","description":"Switch the text display from left to right to right to left  (left to right by default)","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}],"advanced":true},"ishtml":{"required":false,"name":"Content is HTML","description":"When set to 1 (Yes), HTML will still be processed (presented as is by default)","options":[{"text":"","value":""},{"text":"Show HTML","value":"0"},{"text":"Interpret HTML","value":"1"}]},"cpy":{"required":false,"name":"Copy To Clipboard","description":"Copy the contents of the code box to the clipboard  (not copied to clipboard by default)","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}],"advanced":true}}};
tiki_plugins.colorbox = {"name":"colorbox","documentation":"PluginColorBox","description":"Display all the images of a file gallery in a colorbox popup","prefs":["feature_file_galleries","feature_shadowbox","wikiplugin_colorbox"],"introduced":5,"params":{"fgalId":{"required":false,"name":"File Gallery ID","description":"ID number of the file gallery that contains the images to be displayed","filter":"digits","accepted":"ID","default":"","since":"5.0"},"galId":{"required":false,"name":"Image Gallery ID","description":"ID number of the image gallery that contains the images to be displayed","filter":"digits","accepted":"ID","default":"","since":"5.0"},"fileId":{"required":false,"name":"File ID Filter","description":"Filter on fileIds in a file gallery to only show those images. Separate each fileId with ':'","filter":"digits","separator":":","accepted":"ID separated with :","default":"","since":"6.0"},"thumb":{"required":false,"name":"Thumb","description":"Display as a thumbnail (y) or full size (n)","filter":"alpha","accepted":"y or n","default":"y","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"sort_mode":{"required":false,"name":"Sort Mode","description":"Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc.","filter":"word","accepted":"fieldname_asc or fieldname_desc with actual table field name in place of 'fieldname'.","default":"created_desc","since":"5.0"},"showtitle":{"required":false,"name":"Show File Title","description":"Show file title","filter":"alpha","accepted":"y or n","default":"n","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfilename":{"required":false,"name":"Show File Name","description":"Show file name","filter":"alpha","accepted":"y or n","default":"n","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showallthumbs":{"required":false,"name":"Show All Thumbs","description":"Show thumbnails of all the images in the gallery","filter":"alpha","accepted":"y or n","default":"n","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"parsedescriptions":{"required":false,"name":"Parse Descriptions","description":"Wiki parse the file descriptions","filter":"alpha","accepted":"y or n","default":"n","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.content = {"name":"Dynamic Content","documentation":"PluginContent","description":"Includes content from the dynamic content system.","prefs":["feature_dynamic_content","wikiplugin_content"],"filter":"text","params":{"id":{"required":false,"name":"Content ID","description":"Dynamic content ID. The value can be obtained in the listing.","filter":"digits","default":""},"label":{"required":false,"name":"Content Label","description":"Label of the dynamic content to display.","filter":"description","default":""}}};
tiki_plugins.cookie = {"name":"Cookie","documentation":"PluginCookie","description":"Display a rotating set of taglines or quotes (also known as fortune cookies)","prefs":["wikiplugin_cookie"],"params":[]};
tiki_plugins.copyright = {"name":"Copyright","documentation":"PluginCopyright","description":"Insert copyright notices","prefs":["wiki_feature_copyrights","wikiplugin_copyright"],"body":"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~.","params":[]};
tiki_plugins.countdown = {"name":"Countdown","documentation":"PluginCountdown","description":"Displays a countdown from now until the specified date.","prefs":["wikiplugin_countdown"],"icon":"pics\/icons\/clock.png","body":"Text to append to the countdown.","params":{"enddate":{"required":true,"name":"End date","description":"Target date. Multiple formats accepted.","default":""},"locatetime":{"required":false,"name":"Locate Time","description":"Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)","default":"","options":[{"text":"","value":""},{"text":"On","value":"on"},{"text":"Off","value":"off"}]},"show":{"required":false,"name":"Items to Show","description":"Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown.","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Days","value":"d"},{"text":"Days & Hours","value":"dh"},{"text":"Days, Hours & Minutes","value":"dhm"},{"text":"Days, Hours, Minutes & Seconds","value":"dhms"},{"text":"Hours","value":"h"},{"text":"Hours & Minutes","value":"hm"},{"text":"Hours, Minutes & Seconds","value":"hms"},{"text":"Minutes","value":"m"},{"text":"Minutes & Seconds","value":"ms"},{"text":"Seconds","value":"s"}]},"since":{"required":false,"name":"Show time since event","description":"If y, will display amount of time since the event (default). If n will simply display that the event is over.","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.cut = {"name":"Split","documentation":"PluginCut","description":"Cut a page into rows and columns - like SPLIT, but without inserting line breaks.","prefs":["wikiplugin_cut"],"filter":"wikicontent","params":{"joincols":{"required":false,"name":"Join Columns","description":"y|n Generate the colspan attribute if columns are missing","filter":"alpha"},"fixedsize":{"required":false,"name":"Fixed Size","description":"y|n Generate the width attribute on the columns","filter":"alpha"},"colsize":{"required":false,"name":"Column Size","description":"?"},"first":{"required":false,"name":"First","description":"col|line","filter":"alpha"},"edit":{"required":false,"name":"Editable","description":"y|n Display edit icon for each section"},"customclass":{"required":false,"name":"Custom class","description":"add a class to customize the design"}}};
tiki_plugins.datachannel = {"name":"Data Channel","documentation":"PluginDataChannel","description":"Displays a form to trigger data channels.","prefs":["wikiplugin_datachannel"],"body":"List of fields to display. One field per line. Comma delimited: fieldname,label<br \/><br \/>To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\". Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel","extraparams":true,"params":{"channel":{"required":true,"name":"Channel Name","description":"Name of the channel as registered by the administrator.","default":""},"returnURI":{"required":false,"name":"Return URL","description":"URL to go to after data channel has run. Defaults to current page.","filter":"pagename","default":"$_SERVER['HTTP_REFERER']"},"quietReturn":{"required":false,"name":"Do not use returnURI but instead return true quietly","description":"If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context.","default":"n"},"buttonLabel":{"required":false,"name":"Button Label","description":"Label for the submit button. Default: \"Go\".","default":"Go"},"class":{"required":false,"name":"Class","description":"CSS class for this form","default":""},"emptyCache":{"required":false,"name":"Empty Caches","description":"Which caches to empty. Default \"Clear all Tiki caches\"","default":"all","filter":"word","options":[{"text":"","value":""},{"text":"Clear all Tiki caches","value":"all"},{"text":".\/templates_c\/","value":"templates_c"},{"text":".\/modules\/cache\/","value":"modules_cache"},{"text":".\/temp\/cache\/","value":"temp_cache"},{"text":".\/temp\/public\/","value":"temp_public"},{"text":"All user prefs sessions","value":"prefs"},{"text":"None","value":"none"}]},"price":{"required":false,"name":"Price","description":"Price to execute the datachannel (USD).","prefs":["payment_feature"],"default":"","filter":"text"},"paymentlabel":{"required":false,"name":"Payment Label","prefs":["payment_feature"],"default":"","filter":"text"},"debug":{"required":false,"name":"Debug","description":"Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)","default":"n","filter":"word","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"array_values":{"required":false,"name":"Multiple Values","description":"Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)","default":"n","filter":"alpha","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.dbreport = {"name":"DBReport","documentation":"PluginDBReport","description":"Run a database report. This plugin only works with adodb. It does not work with PDO.","prefs":["wikiplugin_dbreport"],"body":"report definition","validate":"all","params":{"dsn":{"required":false,"name":"Full DSN","description":"A full DSN (Data Source Name) connection string. eg: mysql:\/\/user:pass@server\/database","default":""},"db":{"required":false,"name":"Wiki DSN Name","description":"The name of a DSN connection defined by the Wiki administrator.","default":""},"wiki":{"required":false,"name":"Wiki Syntax","description":"Parse wiki syntax within the report (not parsed by default)","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"debug":{"required":false,"name":"Debug","description":"Display the parsed report definition (not displayed by default)","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.div = {"name":"Div","documentation":"PluginDiv","description":"Insert a division block, span, blockquote or other text formatting on wiki page.","prefs":["wikiplugin_div"],"body":"text","params":{"type":{"required":false,"name":"Type","description":"Indicate the type of HTML tag to use (default is div)","filter":"alpha","default":"div","options":[{"text":"None","value":""},{"text":"Div","value":"div"},{"text":"Span","value":"span"},{"text":"Pre","value":"pre"},{"text":"Bold","value":"b"},{"text":"Italic","value":"i"},{"text":"Teletype","value":"tt"},{"text":"Paragraph","value":"p"},{"text":"Block quote","value":"blockquote"}]},"bg":{"required":false,"name":"Background Color","description":"As defined by CSS, name or Hex code.","filter":"striptags","default":""},"width":{"required":false,"name":"Box width","description":"In pixels or percentage. Default is original size","default":""},"align":{"required":false,"name":"Text Alignment","description":"Aligns the text within the element","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Left","value":"left"},{"text":"Right","value":"right"},{"text":"Center","value":"center"},{"text":"Justify","value":"justify"}]},"float":{"required":false,"name":"Float Position","description":"Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Right","value":"right"},{"text":"Left","value":"left"},{"text":"None","value":"none"}]},"clear":{"required":false,"name":"Clear","description":"Items are not allowed to wrap around the side(s) this parameter is set to.","filter":"text","default":"","options":[{"text":"","value":""},{"text":"Right","value":"right"},{"text":"Left","value":"left"},{"text":"Both","value":"both"},{"text":"None","value":"none"}]},"class":{"required":false,"name":"CSS Class","description":"Apply custom CSS class to the div.","filter":"text","default":""},"id":{"required":false,"name":"HTML ID","description":"Sets the div's id attribute, as defined by HTML.","filter":"striptags","default":""}}};
tiki_plugins.dl = {"name":"Definition List","documentation":"PluginDL","description":"Creates a definition list","prefs":["wikiplugin_dl"],"body":"One entry per line. Each line is in \"Term: Definition\" format.","params":[]};
tiki_plugins.equation = {"name":"Equation","documentation":"PluginEquation","description":"Renders an equation written in LaTeX syntax as an image.","prefs":["wikiplugin_equation"],"body":"equation","params":{"size":{"required":false,"name":"Size","description":"Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large.","default":100,"filter":"digits"}}};
tiki_plugins.events = {"name":"Events","documentation":"PluginEvents","description":"Display upcoming events from calendars","prefs":["feature_calendar","wikiplugin_events"],"params":{"calendarid":{"required":true,"name":"Calendar IDs","description":"ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)","default":""},"maxdays":{"required":false,"name":"Maximum Days","description":"Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days.","filter":"digits","default":365},"max":{"required":false,"name":"Maximum Events","description":"Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)","default":10,"filter":"digits"},"datetime":{"required":false,"name":"Show Time","description":"Show the time along with the date (shown by default)","default":1,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"desc":{"required":false,"name":"Show Description","description":"Show the description of the event (shown by default)","default":1,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.fade = {"name":"Fade","documentation":"PluginFade","description":"Displays a label. On click, the block of content will fade in and fade out.","prefs":["wikiplugin_fade"],"body":"Wiki syntax containing the text to display.","filter":"wikicontent","params":{"label":{"required":true,"name":"Label","filter":"striptags","description":"Label to display on first display","default":"Unspecified label"}}};
tiki_plugins.fancylist = {"name":"Fancy List","documentation":"PluginFancyList","description":"Creates a fancy-looking list","prefs":["wikiplugin_fancylist"],"body":"One item per line starting with anything followed by \")\".","params":{"div":{"required":false,"name":"Use Div","description":"Use the HTML tag div instead of the HTML tag for lists (ol)","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"class":{"required":false,"name":"Class","description":"CSS class for the fancylist","default":""}}};
tiki_plugins.fancytable = {"name":"Fancy Table","documentation":"PluginFancyTable","description":"Displays the data using the Tikiwiki odd\/even table style","prefs":["wikiplugin_fancytable"],"body":"Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases.","params":{"head":{"required":false,"name":"Heading Row","description":"Header rows of the table. Use >> to separate multiple rows.","default":""},"headclass":{"required":false,"name":"Heading CSS Class","description":"CSS class to apply to the heading row.","default":""},"headaligns":{"required":false,"name":"Header Horizontal Align","description":"Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify.","default":""},"headvaligns":{"required":false,"name":"Header Vertical Align","description":"Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline.","default":""},"sortable":{"required":false,"name":"Column Sort","description":"Indicate whether columns are sortable or not (not sortable by default)","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"sortList":{"required":false,"name":"Pre-sorted Columns","description":"Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]","default":""},"colwidths":{"required":false,"name":"Column Widths","description":"Column widths followed by px for pixels or % for percentages. Each column separated by |.","default":""},"colaligns":{"required":false,"name":"Cell Horizontal Align","description":"Table body column horizonatal alignments separated by |. Choices: left, right, center, justify.","default":""},"colvaligns":{"required":false,"name":"Cell Vertical Align","description":"Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline.","default":""}}};
tiki_plugins.file = {"name":"File","documentation":"PluginFile","description":"Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead","prefs":["wikiplugin_file"],"body":"Label for the link to the file","icon":"pics\/icons\/file-manager.png","inline":true,"params":{"type":{"required":true,"name":"Type","description":"Indicate whether the file is in a file gallery or is a wiki page attachment","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"File Gallery File\/Archive","value":"gallery"},{"text":"Wiki Page Attachment","value":"attachment"}]},"name":{"required":true,"name":"Name","description":"Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used.","default":"","parent":{"name":"type","value":"attachment"}},"desc":{"required":false,"name":"Custom Description","description":"Custom text that will be used for the link instead of the file name or file description","parent":{"name":"type","value":"attachment"},"advanced":true,"default":""},"page":{"required":false,"name":"Page","description":"Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty.","parent":{"name":"type","value":"attachment"},"default":"","advanced":true},"showdesc":{"required":false,"name":"Attachment Description","description":"Show the attachment description as the link label instead of the attachment file name.","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"parent":{"name":"type","value":"attachment"},"default":"","advanced":true},"image":{"required":false,"name":"Image","description":"Indicates that this attachment is an image, and should be displayed inline using the img tag","parent":{"name":"type","value":"attachment"},"advanced":true,"default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"fileId":{"required":true,"name":"File ID","description":"File ID of a file in a file gallery or an archive. Example value: 42","type":"fileId","area":"fgal_picker_id","filter":"digits","default":"","parent":{"name":"type","value":"gallery"}},"date":{"required":false,"name":"Date","description":"For an archive file, the archive created just before this date will be linked to.","parent":{"name":"type","value":"gallery"},"default":"","advanced":true},"showicon":{"required":false,"name":"Show Icon","description":"Show an icon version of the file or file type with the link to the file.","filter":"alpha","parent":{"name":"type","value":"gallery"},"default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}],"advanced":true}}};
tiki_plugins.files = {"name":"Files","documentation":"PluginFiles","description":"Displays a list of files from a file gallery","prefs":["feature_file_galleries","wikiplugin_files"],"body":"Title","icon":"pics\/large\/file-manager.png","params":{"galleryId":{"required":false,"name":"File Gallery ID","description":"To list only files contained in this file gallery","default":""},"categId":{"required":false,"name":"Category ID","description":"To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon","default":"","advanced":true},"fileId":{"required":false,"name":"File ID","description":"To list only specified files, enter their file IDs separated by colon","type":"fileId","area":"fgal_picker_id","default":"","separator":":"},"sort":{"required":false,"name":"Sort Order","description":"Order ascending or descending based on any field in the file gallery table. Default is name_asc","default":"name_asc"},"showaction":{"required":false,"name":"Show Action","description":"Show a column with icons for the various actions the user can take with each file (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfind":{"required":false,"name":"Show Find","description":"Show a search box above the list (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showtitle":{"required":false,"name":"Show Title","description":"Show the title of the file gallery (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showid":{"required":false,"name":"Show ID","description":"Show the ID number of each file (shown by default)","default":"y","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showicon":{"required":false,"name":"Show Icon","description":"Show an icon for each file depicting the file type","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showname":{"required":false,"name":"Show Name","description":"Show the name given to the file upon upload into the file gallery (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfilename":{"required":false,"name":"Show Filename","description":"Show each file's filename (shown by default)","filter":"alpha","default":"y","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showsize":{"required":false,"name":"Show Size","description":"Show the size of each file in kilobytes (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdescription":{"required":false,"name":"Show Description","description":"Show the description of the file given upon upload into the file gallery (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showcreated":{"required":false,"name":"Show Creation Date","description":"Show the date each file was created (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showmodified":{"required":false,"name":"Show Last Modification Date","description":"Show the date each file was last modified (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showhits":{"required":false,"name":"Show Hits","description":"Show the number of hits each file has received (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlockedby":{"required":false,"name":"Show Locked By","description":"For locked files, show the user name of the user who locked it (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showauthor":{"required":false,"name":"Show Author","description":"Show the user name of the user who is the author of the file (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showcreator":{"required":false,"name":"Show Creator","description":"Show the user name of the user who is the creator of the file (not shown by default)","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showgallery":{"required":false,"name":"Show Parent Gallery Name","description":"Show the name of the parent gallery","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfiles":{"required":false,"name":"Show File Count","description":"For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"slideshow":{"required":false,"name":"Show Slideshow","description":"Show a link that produces a pop-up slide show when clicked (not set by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showcomment":{"required":false,"name":"Show Comment","description":"Show comments for each file (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}],"advanced":true},"showlasteditor":{"required":false,"name":"Show Last Editor","description":"Show the user name of the user who last modified the file (shown by default)","default":"y","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"creator":{"required":false,"name":"Creator","description":"Show only files created by this user","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showupload":{"required":false,"name":"Show Upload","description":"Show a simple upload form to the gallery (not shown by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.flash = {"name":"Flash video","documentation":"PluginFlash","description":"Displays a Flash (.swf) file in the wiki page","prefs":["wikiplugin_flash"],"extraparams":true,"icon":"pics\/icons\/page_white_flash.png","params":{"type":{"required":true,"name":"Flash Type","description":"Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo","default":"","options":[{"text":"Select an option","value":""},{"text":"Blip.tv","value":"bliptv"},{"text":"File Gallery Podcast","value":"fileId"},{"text":"Movie URL","value":"url"},{"text":"Vimeo","value":"vimeo"},{"text":"Youtube","value":"youtube"}]},"movie":{"required":true,"name":"Movie URL","description":"Complete URL to the movie to include. e.g. files\/test.swf","parent":{"name":"type","value":"url"},"default":""},"fileId":{"required":true,"name":"File Gallery Podcast ID","description":"Id of a file from a podcast gallery - will work only with podcast gallery","parent":{"name":"type","value":"fileId"},"default":""},"youtube":{"required":true,"name":"Youtube URL","description":"Entire URL to the YouTube video. Example: http:\/\/www.youtube.com\/watch?v=1i2ZnU4iR24","parent":{"name":"type","value":"youtube"},"default":""},"vimeo":{"required":true,"name":"Vimeo URL","description":"Entire URL to the Vimeo video. Example: http:\/\/vimeo.com\/3319966","parent":{"name":"type","value":"vimeo"},"default":""},"bliptv":{"required":true,"name":"Blip.tv URL","description":"Blip.tv embed URL. Example: http:\/\/blip.tv\/play\/AYGd_GAC","parent":{"name":"type","value":"bliptv"},"default":""},"width":{"required":false,"name":"Width","description":"Width of movie in pixels (default is 425)","advanced":true,"default":425},"height":{"required":false,"name":"Height","description":"Height of movie in pixels (default is 350)","advanced":true,"default":350},"quality":{"required":false,"name":"Quality","description":"Flash video quality. Default value: high","advanced":true,"default":"high","options":[{"text":"","value":""},{"text":"High","value":"high"},{"text":"Medium","value":"medium"},{"text":"Low","value":"low"}]}}};
tiki_plugins.footnote = {"name":"Footnote","documentation":"PluginFootnote","description":"Inserts a superscripted footnote number next to text and takes in footnote as parameter.","prefs":["wikiplugin_footnote"],"body":"The footnote","params":{"sameas":{"required":false,"name":"Sameas","description":"Tag to existing footnote","default":""},"checkDuplicate":{"required":false,"name":"CheckDuplicate","description":"Check for duplicate footnotes","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.footnotearea = {"name":"Footnotearea","documentation":"PluginFootnoteArea","description":"Inserts a section for collected footnotes in the wiki page.","prefs":["wikiplugin_footnotearea"],"params":[]};
tiki_plugins.freetagged = {"name":"Freetagged","documentation":"PluginFreetagged","description":"Find similarly tagged objects","prefs":["wikiplugin_freetagged"],"params":{"tags":{"required":false,"name":"Tags to find similar to","description":"Leave blank to use the object's own tags.","filter":"text","default":""},"type":{"required":false,"name":"Type","description":"Type of objects to extract. Set to All to find all types.","filter":"text","default":null,"options":[{"text":"Same","value":"all"},{"text":"All","value":"all"},{"text":"Wiki Pages","value":"wiki page"},{"text":"Blog Posts","value":"blog post"},{"text":"Article","value":"article"},{"text":"Directory","value":"directory"},{"text":"Faqs","value":"faq"},{"text":"File Galleries","value":"file gallery"},{"text":"Files","value":"file"},{"text":"Polls","value":"poll"},{"text":"Quizzes","value":"quiz"},{"text":"Surveys","value":"survey"},{"text":"Trackers","value":"tracker"}]},"offset":{"required":false,"name":"Offset","description":"Start record.","filter":"text","default":0},"maxRecords":{"required":false,"name":"Max Records","description":"Default -1 (all)","filter":"text","default":-1},"sort_mode":{"required":false,"name":"Sort Order","description":"Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)","filter":"text","default":"created_desc","options":[{"text":"","value":""},{"text":"Comments Locked Ascending","value":"comments_locked_asc"},{"text":"Comments Locked Descending","value":"comments_locked_desc"},{"text":"Created Ascending","value":"created_asc"},{"text":"Created Descending","value":"created_desc"},{"text":"Description Ascending","value":"description_asc"},{"text":"Description Descending","value":"description_desc"},{"text":"Hits Ascending","value":"hits_asc"},{"text":"Hits Descending","value":"hits_desc"},{"text":"Href Ascending","value":"href_asc"},{"text":"Href Descending","value":"href_desc"},{"text":"Item ID Ascending","value":"itemid_asc"},{"text":"Item ID Descending","value":"itemid_desc"},{"text":"Name Ascending","value":"name_asc"},{"text":"Name Descending","value":"name_desc"},{"text":"Object ID Ascending","value":"objectid_asc"},{"text":"Object ID Descending","value":"objectid_desc"},{"text":"Type Ascending","value":"type_asc"},{"text":"Type Descending","value":"type_desc"}]},"find":{"required":false,"name":"Find","description":"Show objects with names or descriptions similar to the text entered here","filter":"text","default":""},"broaden":{"required":false,"name":"Broaden","description":"n|y","filter":"text","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"h_level":{"required":false,"name":"Header Level","description":"Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags.","filter":"int","default":"3"},"titles_only":{"required":false,"name":"Show Titles Only","description":"Choose whether to show titles only (not shown by default)","filter":"text","default":"n","options":[{"text":"No","value":"n"},{"text":"Yes","value":"y"}]},"max_image_size":{"required":false,"name":"Maximum Image Size","description":"Height or width in pixels. Default = 0 (no maximum)","filter":"text","default":0}}};
tiki_plugins.ftp = {"name":"FTP","documentation":"PluginFTP","description":"Download box for a file on an FTP server.","prefs":["wikiplugin_ftp"],"validate":"all","body":"file name","params":{"server":{"required":true,"name":"Server Name","description":"Name of the server where the FTP account is housed. Example: ftp.myserver.com","default":""},"user":{"required":true,"name":"User Name","description":"User name needed to access the FTP account","default":""},"password":{"required":true,"name":"Password","description":"Password needed to access the FTP account","default":""},"title":{"required":false,"name":"Download Button Label","description":"Label for the FTP download button","default":""}}};
tiki_plugins.gauge = {"name":"Gauge","documentation":"PluginGauge","description":"Displays a graphical gauge","prefs":["wikiplugin_gauge"],"body":"description","params":{"value":{"required":true,"name":"Value","description":"Current value to be represented by the gauge","default":""},"max":{"required":false,"name":"Maximum Value","description":"Maximum possible value. Default: 100","default":100},"label":{"required":false,"name":"Label","description":"Label displayed on the left side of the gauge.","default":""},"color":{"required":false,"name":"Color","description":"Main color of the gauge. Use HTML color codes or names.","default":"#FF0000"},"bgcolor":{"required":false,"name":"Background Color","description":"Background color of the gauge. Use HTML color codes or names.","default":"#0000FF"},"size":{"required":false,"name":"Width","description":"Bar width in pixels.","filter":"digits","default":150},"labelsize":{"required":false,"name":"Label Width","description":"Width in pixels allocated to the label.","filter":"digits","default":50},"perc":{"required":false,"name":"Display Percentage","description":"Set to true (Yes) to display a percentage of the maximum.","default":false,"options":[{"text":"","value":""},{"text":"Yes","value":true},{"text":"No","value":false}]},"showvalue":{"required":false,"name":"Display Value","description":"Set to false (No) to hide the numeric value (shown by default).","default":true,"options":[{"text":"","value":""},{"text":"Yes","value":true},{"text":"No","value":false}]},"height":{"required":false,"name":"Height","description":"Bar height in pixels.","filter":"digits","default":14}}};
tiki_plugins.googleanalytics = {"name":"Google Analytics","documentation":"PluginGoogleAnalytics","description":"Add the tracking code for Google Analytics.","prefs":["wikiplugin_googleanalytics"],"params":{"account":{"required":true,"name":"Account Number","description":"The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY","default":""}}};
tiki_plugins.googledoc = {"name":"Google Doc","documentation":"PluginGoogleDoc","description":"Displays a Google document","prefs":["wikiplugin_googledoc"],"body":"Leave this empty.","params":{"type":{"safe":true,"required":true,"name":"Type","description":"Type of Google document","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Document","value":"document"},{"text":"Presentation","value":"presentation"},{"text":"Spreadsheet","value":"speadsheet"}]},"key":{"safe":true,"required":true,"name":"key","description":"Google doc key - for example: pXsHENf1bGGY92X1iEeJJI","default":""},"name":{"safe":true,"required":false,"name":"Name","description":"Name of iframe. Default is \"Frame\" + the key"},"size":{"safe":true,"required":false,"name":"Size","description":"Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly.","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Small","value":"small"},{"text":"Medium","value":"medium"},{"text":"Large","value":"large"}]},"width":{"safe":true,"required":false,"name":"Width","description":"Width in pixels or %","filter":"digits","default":800},"height":{"safe":true,"required":false,"name":"Height","description":"Height in pixels or %","filter":"digits","default":400},"align":{"safe":true,"required":false,"name":"Alignment","description":"top|middle|bottom|left|right","default":"","options":[{"text":"","value":""},{"text":"Top","value":"top"},{"text":"Middle","value":"middle"},{"text":"Bottom","value":"bottom"},{"text":"Left","value":"left"},{"text":"Right","value":"right"}]},"frameborder":{"safe":true,"required":false,"name":"Frame Border","description":"Choose whether to show a border around the iframe","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"marginheight":{"safe":true,"required":false,"name":"Margin Height","description":"Margin height in pixels","default":""},"marginwidth":{"safe":true,"required":false,"name":"Margin Width","description":"Margin width in pixels","default":""},"scrolling":{"safe":true,"required":false,"name":"Scrolling","description":"Choose whether to add a scroll bar","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"yes"},{"text":"No","value":"no"},{"text":"Auto","value":"auto"}]},"editLink":{"safe":true,"required":false,"name":"Edit Link","description":"Choose whether to show an edit link and set its location","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Top","value":"top"},{"text":"Bottom","value":"bottom"},{"text":"Both","value":"both"}]}}};
tiki_plugins.googlemap = {"name":"googlemap","documentation":"PluginGoogleMap","description":"Displays a Google map","prefs":["wikiplugin_googlemap"],"params":{"type":{"safe":true,"required":true,"name":"Type","description":"Type of items to show on google map","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Item","value":"item"},{"text":"Locator","value":"locator"},{"text":"Object List","value":"objectlist"},{"text":"Tracker Field","value":"trackerfield"},{"text":"User","value":"user"}]},"mode":{"safe":true,"required":true,"name":"Display Mode","description":"Map display mode","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Normal","value":"normal"},{"text":"Satellite","value":"satellite"},{"text":"Hybrid","value":"hybrid"}]},"key":{"safe":true,"required":false,"name":"API Key","description":"Google maps key, if not set in user preferences","default":""},"name":{"safe":true,"required":false,"name":"Map ID","description":"Id suffix of Google map div to avoid conflicts with other maps on same page","default":"default"},"width":{"safe":true,"required":false,"name":"Width","description":"Width in pixels or %","default":500},"height":{"safe":true,"required":false,"name":"Height","description":"Height in pixels or %","default":400},"frameborder":{"safe":true,"required":false,"name":"Show Border","description":"Choose whether to show a frame border around the map (no border shown by default).","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"defaultx":{"safe":true,"required":false,"name":"Default Center Longitude","description":"Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature."},"defaulty":{"safe":true,"required":false,"name":"Default Center Latitude","description":"Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature."},"defaultz":{"safe":true,"required":false,"name":"Default Zoom","description":"Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature.","filter":"int"},"setdefaultxyz":{"safe":true,"required":false,"name":"Save View","description":"Allow user to set current map view as default view for himself only","default":false,"options":[{"text":"","value":""},{"text":"Yes","value":true},{"text":"No","value":false}]},"locateitemtype":{"safe":true,"required":false,"name":"Item Type","description":"Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified.","default":""},"locateitemid":{"safe":true,"required":false,"name":"Item ID","description":"ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified","default":""},"hideifnone":{"safe":true,"required":false,"name":"Hide If No Markers","description":"Hide map if there are no markers to be shown. Default is to show the map.","default":false,"options":[{"text":"","value":""},{"text":"Yes","value":true},{"text":"No","value":false}]},"togglehidden":{"safe":true,"required":false,"name":"Visibility Toggle","description":"Add ability to toggle visibility. No toggle by default.","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"starthidden":{"safe":true,"required":false,"name":"Start Hidden","description":"Choose whether to keep the map hidden initially. Default is to show the map initially.","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"autozoom":{"safe":true,"required":false,"name":"Auto Zoom","description":"Use an integer between 0 and 19 to auto zoom to this level on address find","default":"","filter":"int","options":[{"text":"","value":""},{"text":0,"value":0},{"text":1,"value":1},{"text":2,"value":2},{"text":3,"value":3},{"text":4,"value":4},{"text":5,"value":5},{"text":6,"value":6},{"text":7,"value":7},{"text":8,"value":8},{"text":9,"value":9},{"text":10,"value":10},{"text":11,"value":11},{"text":12,"value":12},{"text":13,"value":13},{"text":14,"value":14},{"text":15,"value":15},{"text":16,"value":16},{"text":17,"value":17},{"text":18,"value":18},{"text":19,"value":19}]},"controls":{"safe":true,"required":false,"name":"Show Controls","description":"Show map controls (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"trackerfieldid":{"safe":true,"required":false,"name":"Tracker Field ID","description":"Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem","filter":"int","default":0},"trackerinputid":{"safe":true,"required":false,"name":"HTML ID","description":"HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms","default":""},"in_form":{"safe":true,"required":false,"name":"In Form","description":"Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML.","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.group = {"name":"Group","documentation":"PluginGroup","description":"Display wiki text if user is in one of listed groups","body":"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition.","prefs":["wikiplugin_group"],"icon":"pics\/icons\/group.png","filter":"wikicontent","params":{"friends":{"required":false,"name":"Allowed User Friends","description":"Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo","filter":"username","default":""},"groups":{"required":false,"name":"Allowed Groups","description":"Pipe separated list of groups allowed to view the block. ex: Admins|Developers","filter":"groupname","default":""},"notgroups":{"required":false,"name":"Denied Groups","description":"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers","filter":"groupname","default":""}}};
tiki_plugins.grouplist = {"name":"Group List","documentation":"PluginGroupList","description":"List all groups or just groups that include a certain group","params":{"group":{"required":false,"name":"Group Name","description":"If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed.","filter":"groupname"},"linkhome":{"required":false,"name":"Group Home Page","description":"Link the group name to the group home page, if there is one (not linked by default)","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"recur":{"required":false,"name":"Recursively List Groups","description":"Recurse on the included groups (default is not to recurse)","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.groupmailcore = {"name":"GroupMailCore","documentation":"PluginGroupMailCore","description":"Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile.","prefs":["wikiplugin_groupmailcore","feature_trackers"],"params":{"fromEmail":{"required":true,"name":"From Email","description":"Email address to report.","default":""},"trackerId":{"required":true,"name":"Tracker Id","description":"Id of GroupMail Logs tracker (set up in alias by profile).","filter":"digits","default":""},"fromFId":{"required":true,"name":"From Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"operatorFId":{"required":true,"name":"Operator Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"subjectFId":{"required":true,"name":"Subject Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"messageFId":{"required":true,"name":"Message Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"contentFId":{"required":true,"name":"Content Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"accountFId":{"required":true,"name":"Account Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""},"datetimeFId":{"required":true,"name":"Datetime Field Id","description":"Id of GroupMail Logs tracker field (usually set up in alias by profile).","filter":"digits","default":""}}};
tiki_plugins.groupstat = {"name":"Group Stats","documentation":"PluginGroupStat","description":"Displays the percentage of total users that are members of groups","body":"Title","params":{"groups":{"required":false,"name":"Groups","description":"Groups separated by :. If empty, all groups will be listed."},"show_percent":{"required":false,"name":"Show Percentage","description":"Show the percentage of total users that are members of each group (percentages are shown by default)","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_bar":{"required":false,"name":"Show Bar","description":"Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.html = {"name":"HTML","documentation":"PluginHTML","description":"Include literal HTML in a Wiki page","prefs":["wikiplugin_html"],"body":"HTML code","validate":"all","filter":"rawhtml_unsafe","icon":"pics\/icons\/html.png","params":{"wiki":{"required":false,"name":"Wiki syntax","description":"Parse wiki syntax within the html code.","options":[{"text":"","value":""},{"text":"No","value":0},{"text":"Yes","value":1}],"filter":"int","default":""}}};
tiki_plugins.iframe = {"name":"Iframe","documentation":"PluginIframe","description":"Displays an iframe","prefs":["wikiplugin_iframe"],"body":"URL","validate":"all","params":{"name":{"safe":true,"required":false,"name":"Name","description":"Name","default":""},"title":{"safe":true,"required":false,"name":"Title","description":"Frame title","default":""},"width":{"safe":true,"required":false,"name":"Width","description":"Width in pixels or %","default":""},"height":{"safe":true,"required":false,"name":"Height","description":"Pixels or %","default":""},"align":{"safe":true,"required":false,"name":"Alignment","description":"Align the ifram on the page","default":"","options":[{"text":"","value":""},{"text":"Top","value":"top"},{"text":"Middle","value":"middle"},{"text":"Bottom","value":"bottom"},{"text":"Left","value":"left"},{"text":"Right","value":"right"}]},"frameborder":{"safe":true,"required":false,"name":"Frame Border","description":"Choose whether to show a border around the iframe","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"marginheight":{"safe":true,"required":false,"name":"Margin Height","description":"Margin height in pixels","default":""},"marginwidth":{"safe":true,"required":false,"name":"Margin Width","description":"Margin width in pixels","default":""},"scrolling":{"safe":true,"required":false,"name":"Scrolling","description":"Choose whether to add a scroll bar","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"yes"},{"text":"No","value":"no"},{"text":"Auto","value":"auto"}]},"src":{"required":false,"name":"URL","description":"URL","default":""}}};
tiki_plugins.img = {"name":"Image","documentation":"PluginImg","description":"Display images","prefs":["wikiplugin_img"],"icon":"pics\/icons\/picture.png","params":{"src":{"required":false,"name":"Image source","type":"image","area":"fgal_picker","description":"Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required.","filter":"url","default":""},"id":{"required":false,"name":"Image ID","description":"Numeric ID of an image in an Image Gallery (or list separated by commas or |).","filter":"striptags","default":""},"fileId":{"required":false,"name":"File ID","type":"image","area":"fgal_picker_id","description":"Numeric ID of an image in a File Gallery (or list separated by commas or |).","filter":"striptags","default":""},"randomGalleryId":{"required":false,"name":"Gallery ID","description":"Numeric ID of a File Gallery. Displays a random image from that gallery.","filter":"int","advanced":true,"default":""},"attId":{"required":false,"name":"Attachment ID","description":"Numeric ID of an image attached to a wiki page (or list separated by commas or |).","filter":"striptags","default":""},"thumb":{"required":false,"name":"Thumbnail","description":"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments.","filter":"alpha","default":"","options":[{"text":"None","value":""},{"text":"Yes","value":"y","description":"Full size image appears when thumbnail is clicked."},{"text":"Mouseover","value":"mouseover","description":"Full size image will pop up while cursor is over the thumbnail (and disappear when not)."},{"text":"Mouseover (Sticky)","value":"mousesticky","description":"Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup."},{"text":"Popup","value":"popup","description":"Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked."},{"text":"Browse","value":"browse","description":"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery"},{"text":"Browse Popup","value":"browsepopup","description":"Same as \"browse\" except that the page opens in a new window or tab."},{"text":"Download","value":"download","description":"Download dialog box will appear for file gallery and attachment images when thumbnail is clicked."}]},"button":{"required":false,"name":"Enlarge button","description":"Button for enlarging image.","filter":"alpha","default":"","options":[{"text":"None","value":""},{"text":"Yes","value":"y"},{"text":"Popup","value":"popup","description":"Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked."},{"text":"Browse","value":"browse","description":"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery"},{"text":"Browse Popup","value":"browsepopup","description":"Same as \"browse\" except that the page opens in a new window or tab."},{"text":"Download","value":"download","description":"Download dialog box will appear for file gallery and attachment images when thumbnail is clicked."}]},"link":{"required":false,"name":"Link","description":"Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting.","filter":"url","default":""},"rel":{"required":false,"name":"Link relation","filter":"striptags","description":"Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation.","advanced":true,"default":""},"usemap":{"required":false,"name":"Image map","filter":"striptags","description":"Name of the image map to use for the image.","advanced":true,"default":""},"height":{"required":false,"name":"Image height","description":"Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent.","filter":"striptags","default":""},"width":{"required":false,"name":"Image width","description":"Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent.","filter":"striptags","default":""},"max":{"required":false,"name":"Maximum image size","description":"Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings.","filter":"int","default":""},"imalign":{"required":false,"name":"Align image","description":"Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box.","filter":"alpha","advanced":true,"default":"","options":[{"text":"None","value":""},{"text":"Right","value":"right"},{"text":"Left","value":"left"},{"text":"Center","value":"center"}]},"styleimage":{"required":false,"name":"Image style","description":"Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects.","filter":"striptags","advanced":true,"default":""},"align":{"required":false,"name":"Align image block","description":"Aligns the box containing the image.","filter":"alpha","advanced":true,"default":"","options":[{"text":"None","value":""},{"text":"Right","value":"right"},{"text":"Left","value":"left"},{"text":"Center","value":"center"}]},"stylebox":{"required":false,"name":"Image block style","filter":"striptags","description":"Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects.","advanced":true,"default":""},"styledesc":{"required":false,"name":"Description style","filter":"striptags","description":"Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects.","advanced":true,"default":""},"block":{"required":false,"name":"Wrapping control","description":"Control how other items wrap around the image.","filter":"alpha","advanced":true,"default":"","options":[{"text":"None","value":""},{"text":"Top","value":"top"},{"text":"Bottom","value":"bottom"},{"text":"Both","value":"both"}]},"class":{"required":false,"name":"CSS Class","filter":"striptags","description":"CSS class to apply to the image.","advanced":true,"default":""},"desc":{"required":false,"name":"Caption","filter":"text","description":"Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description.","default":""},"title":{"required":false,"name":"Link title","filter":"text","description":"Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title.","advanced":true,"default":""},"alt":{"required":false,"name":"Alternate text","filter":"text","description":"Alternate text that displays when image does not load. Set to \"Image\" by default.","default":"Image"},"default":{"required":false,"name":"Default config settings","description":"Default configuration settings (usually set by admin in the source code or through Plugin Alias).","advanced":true,"default":""},"mandatory":{"required":false,"name":"Mandatory admin setting","description":"Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias).","advanced":true,"default":""}}};
tiki_plugins.include = {"name":"Include","documentation":"PluginInclude","description":"Include a page's content.","prefs":["wikiplugin_include"],"params":{"page":{"required":true,"name":"Page Name","description":"Wiki page name to include.","filter":"pagename","default":""},"start":{"required":false,"name":"Start","description":"When only a portion of the page should be included, specify the marker from which inclusion should start.","default":""},"stop":{"required":false,"name":"Stop","description":"When only a portion of the page should be included, specify the marker at which inclusion should end.","default":""},"nopage_text":{"required":false,"name":"Nopage Text","description":"Text to show when no page is found.","default":""},"pagedenied_text":{"required":false,"name":"Page Denied Text","description":"Text to show when the page exists but is denied to the user.","default":""}}};
tiki_plugins.invite = {"name":"Invite","documentation":"PluginInvite","description":"Invite an email in groups.","prefs":["wikiplugin_invite"],"body":"Confirmation message after posting form","params":{"including":{"required":false,"name":"Including Group","description":"Will list only the groups that include this group"},"defaultgroup":{"required":false,"name":"Default Group","description":"Dropdown list will show this group by default"},"itemId":{"required":false,"name":"Item ID","description":"Dropdown list will show the group related to this item ID (in group selector or creator field) by default"}}};
tiki_plugins.jabber = {"name":"Jabber","documentation":"PluginJabber","description":"Runs a Java applet to access a local Jabber service","prefs":["wikiplugin_jabber"],"params":{"height":{"required":false,"name":"Height","description":"Applet height in pixels","default":200},"width":{"required":false,"name":"Width","description":"Applet width in pixels","default":200},"xmlhostname":{"required":false,"name":"XML Host Name","description":"Web site where XML is hosted. Default is jabber.org","default":"jabber.org"},"defaultColor":{"required":false,"name":"Default Color","description":"Set default color. Default is 255,255,255","default":"255,255,255"}}};
tiki_plugins.jq = {"name":"jQuery","documentation":"PluginJQ","description":"Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded.","prefs":["wikiplugin_jq"],"body":"JavaScript code","validate":"all","filter":"none","params":{"notonready":{"required":false,"name":"Not On Ready","description":"Do not execute on document ready (execute inline)"},"nojquery":{"required":false,"name":"No JavaScript","description":"Optional markup for when JavaScript is off"}}};
tiki_plugins.js = {"name":"Javascript","documentation":"PluginJS","description":"Insert a javascript file and\/or some javascript code.","prefs":["wikiplugin_js"],"body":"javascript code","validate":"all","filter":"rawhtml_unsafe","params":{"file":{"required":false,"name":"File","description":"Javascript filename","filter":"url","default":""}}};
tiki_plugins.kaltura = {"name":"Kaltura video","documentation":"PluginKaltura","description":"Displays a KALTURA video on the wiki page","prefs":["wikiplugin_kaltura"],"extraparams":true,"params":{"id":{"required":true,"name":"Kaltura Entry ID","description":"Kaltura entry ID of the video to be displayed"}}};
tiki_plugins.lang = {"name":"Language","documentation":"PluginLang","description":"Displays the text only if the language matches","prefs":["feature_multilingual","wikiplugin_lang"],"body":"text","params":{"lang":{"required":false,"name":"Language","description":"List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs.","default":""},"notlang":{"required":false,"name":"Not Language","description":"List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs.","default":""}}};
tiki_plugins.lastmod = {"name":"Last Modification","documentation":"PluginLastMod","description":"The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given","prefs":["feature_wiki","wikiplugin_lastmod"],"params":{"page":{"required":false,"name":"Page","description":"Page name to display information of. Default value is current page."}}};
tiki_plugins.lex = {"name":"Lex","description":"Links to an entry in the Ogre Lexicon","prefs":["wikiplugin_lex"],"body":"text","icon":"img\/icons\/book.gif","params":{"pagename":{"name":"Page Name","description":"By default, the lexicon link will be the selected text prepended with a dash. This parameter allows you to link to something else.","required":false}}};
tiki_plugins.listpages = {"name":"List Pages","documentation":"PluginListpages","description":"List wiki pages.","prefs":["wikiplugin_listpages"],"icon":"pics\/icons\/page_white_stack.png","params":{"offset":{"required":false,"name":"Result Offset","description":"Result number at which the listing should start.","filter":"digits","default":0},"max":{"required":false,"name":"Max","description":"Limit number of items displayed in the list. Default is to display all.","filter":"digits","default":-1},"initial":{"required":false,"name":"Initial","description":"txt","default":""},"showNameOnly":{"required":false,"name":"Show Name Only","description":"Show only the page names","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"categId":{"required":false,"name":"Category filter","description":"If set to a category identifier, restrict the pages displayed to those in the specified category. Example value: 42. If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories. Example value: 1:2. If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories. Example value: 1+2. If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories. Example value: 1-2-3.","filter":"striptags"},"structHead":{"required":false,"name":"Structure Head","description":"Filter by structure head","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showPageAlias":{"required":false,"name":"Show Page Alias","description":"Show page alias in the list","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"find":{"required":false,"name":"Find","description":"Only pages with names similar the text entered for this parameter will be listed"},"lang":{"required":false,"name":"Language","description":"Two letter language code to filter pages listed.","filter":"alpha"},"langOrphan":{"required":false,"name":"Orphan Language","description":"Two letter language code to filter pages listed. Only pages not available in the provided language will be listed.","filter":"alpha"},"translations":{"required":false,"name":"Load Translations","description":"User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter."},"exact_match":{"required":false,"name":"Exact Match","description":"Page name and text entered for the filter parameter must match exactly to be listed","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"only_orphan_pages":{"required":false,"name":"Only Orphan Pages","description":"Only list orphan pages","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"for_list_pages":{"required":false,"name":"For List Pages","description":"y|n","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"sort":{"required":false,"name":"Sort","description":"Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: lastModif_descorpageName_asc","default":"pageName_asc"},"start":{"required":false,"name":"Start","description":"When only a portion of the page should be included, specify the marker from which inclusion should start.","default":""},"end":{"required":false,"name":"Stop","description":"When only a portion of the page should be included, specify the marker at which inclusion should end.","default":""},"length":{"required":false,"name":"Length","description":"Number of characters to display","filter":"int","default":""}}};
tiki_plugins.lsdir = {"name":"List Directory","documentation":"PluginLsDir","description":"Lists files in a directory","prefs":["wikiplugin_lsdir"],"validate":"all","params":{"dir":{"required":true,"name":"Directory","description":"Full path to the server-local directory. Default is the document root.","default":""},"urlprefix":{"required":false,"name":"URL Prefix","description":"Make the file name a link to the file by adding the url path preceding the file name. Example: http:\/\/yoursite.com\/tiki\/","default":null},"sort":{"required":false,"name":"Sort Order","description":"Set the sort order of the file list","default":"name","options":[{"text":"","value":""},{"text":"File Name","value":"name"},{"text":"File Size","value":"size"},{"text":"Last Access","value":"atime"},{"text":"Last Metadata Change","value":"ctime"},{"text":"Last Modified","value":"mtime"}]},"filter":{"required":false,"name":"Filter","description":"Only list files with filenames that contain this filter. Example: \".jpg\"","default":null},"limit":{"required":false,"name":"Limit","description":"Maximum amount of files to display. Default is no limit.","default":0}}};
tiki_plugins.mail = {"name":"Mail","documentation":"PluginMail","description":"Directly mail other users or groups","validate":"all","params":{"group":{"required":false,"name":"Group","description":"Limit the group to the groups including this group","filter":"groupname","default":""},"showgroupdd":{"required":false,"name":"Show Group Dropdown","description":"Show a dropdown list of groups (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showuserdd":{"required":false,"name":"Show User Dropdown","description":"Show a dropdown list of users (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showuser":{"required":false,"name":"User Autocomplete","description":"Show an autocomplete box on user name","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showrealnamedd":{"required":false,"name":"Real Name Dropdown","description":"Show a dropdown list of user real names (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.map = {"name":"Map","documentation":"PluginMap","description":"Displays a map","prefs":["feature_maps","wikiplugin_map"],"icon":"pics\/icons\/map.png","params":{"mapfile":{"required":true,"name":"Map File","description":"Map file identifier"},"extents":{"required":false,"name":"Extents","description":"Extents"},"size":{"required":false,"name":"Size","description":"Size of the map"},"width":{"required":false,"name":"Width","description":"Width of the map"},"height":{"required":false,"name":"Height","description":"Height of the map"}}};
tiki_plugins.mcalendar = {"name":"Mayan Calendars Info","documentation":"PluginMCalendarInfo","description":"Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count.","prefs":["wikiplugin_mcalendar"],"params":{"template":{"required":false,"name":"Template","description":"You must use the variable substitution.<br \/>LongCount: ~np~%baktun%, %katun%, %tun%, %winal%, %kin%~\/np~<br \/>Tzolkin: ~np~%tzolkin13%, %tzolkin20%, %tzolkin20name%~\/np~<br \/>Haab: ~np~%haabkin%, %haabwinal%, %haabwinalname%~\/np~<br \/>Misc: ~np~%longkin%, %julianday%~\/np~<br \/><br \/>Example: template ~np~\"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" ~\/np~for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br \/><br \/>Default template: ~np~%baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%~\/np~"},"grdate":{"required":false,"name":"Gregorian date","description":"Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date"}}};
tiki_plugins.mediaplayer = {"name":"Mediaplayer","documentation":"PluginMediaplayer","description":"Simple mp3 or flv Player","extraparams":true,"prefs":["wikiplugin_mediaplayer"],"params":{"fullscreen":{"required":false,"name":"Allow Fullscreen","description":"Allow fullscreen mode. true|false","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"true"},{"text":"No","value":"false"}]},"mp3":{"required":false,"name":"MP3 URL","description":"Complete URL to the mp3 to include.","filter":"url"},"flv":{"required":false,"name":"FLV URL","description":"Complete URL to the flv to include.","filter":"url"},"src":{"required":false,"name":"URL","description":"Complete URL to the media to include. asx, asf, avi, flv, mov, mpg, mpeg, mp4, qt, ra, smil, swf, wmv, 3g2, 3gp,aif, aac, au, gsm, mid, midi, mov, mp3, m4a, snd, ra, ram, rm, wav, wma, bmp, html, pdf, psd, qif, qtif, qti, tif, tiff, xaml","filter":"url","default":""},"style":{"required":false,"name":"Style","description":"One of:mini|normal|maxi|multi","filter":"alpha","options":[{"text":"","value":""},{"text":"Mini","value":"mini"},{"text":"Normal","value":"normal"},{"text":"Maxi","value":"maxi"},{"text":"Multi","value":"multi"}]},"wmode":{"required":false,"name":"Flash Window Mode","description":"Sets the Window Mode property of the Flash movie. Transparent lets what's behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what's behind the movie and Window plays the movie in its own window. Default value: transparent","filter":"alpha","options":[{"text":"","value":""},{"text":"Transparent","value":"transparent"},{"text":"Opaque","value":"opaque"},{"text":"Window","value":"window"}]}}};
tiki_plugins.memberlist = {"name":"Member List","documentation":"PluginMemberList","description":"Lists the members of selected groups and allows to add or remove members if permissions are granted.","prefs":["wikiplugin_memberlist"],"filter":"wikicontent","params":{"groups":{"required":true,"name":"Groups","description":"List of groups to handle through the interface. Colon separated.","separator":":","filter":"groupname","default":""}}};
tiki_plugins.memberpayment = {"name":"Member Payment","documentation":"PluginMemberPayment","description":"Receive payments from a member and extend the length of the membership to a group.","validate":"all","prefs":["wikiplugin_memberpayment","payment_feature"],"params":{"group":{"required":true,"name":"Group","description":"Name of the group for which the subscription should be added or extended.","filter":"groupname","default":""},"price":{"required":true,"name":"Price","description":"Price per period (USD).","filter":"text"},"currentuser":{"required":false,"name":"Current User Member","description":"Membership only for the current user","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"inputtitle":{"required":false,"name":"Input Title","description":"Title of the input form. Use %0 for the group name. Supports wiki syntax","filter":"text","default":"Membership to %0 for %1 (x%2)"},"howtitle":{"required":false,"name":"How Title","description":"Title of the input form. Use %0 for the group name, %4 for the number of days or %5 for the number of years Supports wiki syntax","filter":"text","default":"Membership to %0 for %1 (x%2)"}}};
tiki_plugins.miniquiz = {"name":"Mini Quiz","documentation":"PluginMiniQuiz","description":"Displays a miniquiz","prefs":["feature_trackers","wikiplugin_miniquiz"],"body":"Instructions::Feedback","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the miniquiz tracker ID","default":""}}};
tiki_plugins.module = {"name":"Insert Module","documentation":"PluginModule","description":"Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface.","prefs":["wikiplugin_module"],"validate":"all","icon":"pics\/icons\/module.png","extraparams":true,"params":{"module":{"required":true,"name":"Module Name","description":"Module name as known in Tiki","default":"","options":[{"text":"Action calendar (action_calendar)","value":"action_calendar"},{"text":"AdminMenu (AdminMenu)","value":"AdminMenu"},{"text":"Application Menu (Application Menu)","value":"Application Menu"},{"text":"Article Topics (article_topics)","value":"article_topics"},{"text":"Article archives (article_archives)","value":"article_archives"},{"text":"Articles (articles)","value":"articles"},{"text":"Best rated topics (forums_best_voted_topics)","value":"forums_best_voted_topics"},{"text":"BetterAdmin (BetterAdmin)","value":"BetterAdmin"},{"text":"Calendar (calendar_new)","value":"calendar_new"},{"text":"Cart (cart)","value":"cart"},{"text":"Categories (categories)","value":"categories"},{"text":"Category Transitions (category_transition)","value":"category_transition"},{"text":"Change Category (change_category)","value":"change_category"},{"text":"Directory statistics (directory_stats)","value":"directory_stats"},{"text":"Featured links (featured_links)","value":"featured_links"},{"text":"Feeds List (rsslist)","value":"rsslist"},{"text":"File galleries (file_galleries)","value":"file_galleries"},{"text":"Freetags Wiki (freetags_current)","value":"freetags_current"},{"text":"Freetags editor (freetag)","value":"freetag"},{"text":"Freetags similar content (freetags_morelikethis)","value":"freetags_morelikethis"},{"text":"Google AdSense (adsense)","value":"adsense"},{"text":"Google Search (google)","value":"google"},{"text":"Groups emulation (groups_emulation)","value":"groups_emulation"},{"text":"Last Created FAQs (last_created_faqs)","value":"last_created_faqs"},{"text":"Last Created Quizzes (last_created_quizzes)","value":"last_created_quizzes"},{"text":"Last Created blogs (last_created_blogs)","value":"last_created_blogs"},{"text":"Last Files (last_files)","value":"last_files"},{"text":"Last Images (last_images)","value":"last_images"},{"text":"Last Modified blogs (last_modified_blogs)","value":"last_modified_blogs"},{"text":"Last Podcasts (last_podcasts)","value":"last_podcasts"},{"text":"Last Validated FAQs Questions (last_validated_faq_questions)","value":"last_validated_faq_questions"},{"text":"Last Visitors (last_visitors)","value":"last_visitors"},{"text":"Last actions (last_actions)","value":"last_actions"},{"text":"Last blog post comments (blog_last_comments)","value":"blog_last_comments"},{"text":"Last blog posts (last_blog_posts)","value":"last_blog_posts"},{"text":"Last category objects (last_category_objects)","value":"last_category_objects"},{"text":"Last changes (last_modif_pages)","value":"last_modif_pages"},{"text":"Last comments (wiki_last_comments)","value":"wiki_last_comments"},{"text":"Last directory sites (directory_last_sites)","value":"directory_last_sites"},{"text":"Last forum posts (forums_last_posts)","value":"forums_last_posts"},{"text":"Last modified events (last_modif_events)","value":"last_modif_events"},{"text":"Last modified file galleries (last_file_galleries)","value":"last_file_galleries"},{"text":"Last modified image galleries (last_image_galleries)","value":"last_image_galleries"},{"text":"Last submissions (last_submissions)","value":"last_submissions"},{"text":"Last tracker comments (last_tracker_comments)","value":"last_tracker_comments"},{"text":"Last tracker items (last_tracker_items)","value":"last_tracker_items"},{"text":"Last visited pages (breadcrumb)","value":"breadcrumb"},{"text":"Live support (live_support)","value":"live_support"},{"text":"Login (login_box)","value":"login_box"},{"text":"Logo (logo)","value":"logo"},{"text":"Main Menu (Main Menu)","value":"Main Menu"},{"text":"Menu page (menupage)","value":"menupage"},{"text":"Menu structure (menustructure)","value":"menustructure"},{"text":"Minichat (minichat)","value":"minichat"},{"text":"Months links (months_links)","value":"months_links"},{"text":"Most Active blogs (top_active_blogs)","value":"top_active_blogs"},{"text":"Most commented (most_commented)","value":"most_commented"},{"text":"Most commented forums (forums_most_commented_forums)","value":"forums_most_commented_forums"},{"text":"Most popular tags (freetags_most_popular)","value":"freetags_most_popular"},{"text":"Most read topics (forums_most_read_topics)","value":"forums_most_read_topics"},{"text":"Most visited blogs (top_visited_blogs)","value":"top_visited_blogs"},{"text":"Most visited forums (forums_most_visited_forums)","value":"forums_most_visited_forums"},{"text":"MyTiki (MyTiki)","value":"MyTiki"},{"text":"New user registration (register)","value":"register"},{"text":"Ogre Feeds (Ogre Feeds)","value":"Ogre Feeds"},{"text":"Old articles (old_articles)","value":"old_articles"},{"text":"Online users (who_is_there)","value":"who_is_there"},{"text":"PageTracker (PageTracker)","value":"PageTracker"},{"text":"Perspective (perspective)","value":"perspective"},{"text":"Public tasks (user_tasks_public)","value":"user_tasks_public"},{"text":"Quick Edit (quick_edit)","value":"quick_edit"},{"text":"Random Pages (random_pages)","value":"random_pages"},{"text":"Random image (random_images)","value":"random_images"},{"text":"Received objects (comm_received_objects)","value":"comm_received_objects"},{"text":"Search (search)","value":"search"},{"text":"Search Wiki Page (search_wiki_page)","value":"search_wiki_page"},{"text":"Search box (search_box)","value":"search_box"},{"text":"SearchTags (SearchTags)","value":"SearchTags"},{"text":"Semantic links (semantic_links)","value":"semantic_links"},{"text":"Shoutbox (shoutbox)","value":"shoutbox"},{"text":"Similar Content (action_similarcontent)","value":"action_similarcontent"},{"text":"Since last visit (since_last_visit_new)","value":"since_last_visit_new"},{"text":"Since last visit (simple) (since_last_visit)","value":"since_last_visit"},{"text":"Switch Language (switch_lang)","value":"switch_lang"},{"text":"Switch theme (switch_theme)","value":"switch_theme"},{"text":"Terminology (terminology)","value":"terminology"},{"text":"Tiki Tests (tikitests)","value":"tikitests"},{"text":"Tiki User Credits (credits)","value":"credits"},{"text":"TikiWiki assistant (assistant)","value":"assistant"},{"text":"Top File Galleries (top_file_galleries)","value":"top_file_galleries"},{"text":"Top Forum Posters (top_forum_posters)","value":"top_forum_posters"},{"text":"Top Images (top_images)","value":"top_images"},{"text":"Top Objects (top_objects)","value":"top_objects"},{"text":"Top Pages (top_pages)","value":"top_pages"},{"text":"Top Quizzes (top_quizzes)","value":"top_quizzes"},{"text":"Top Visited FAQs (top_visited_faqs)","value":"top_visited_faqs"},{"text":"Top articles (top_articles)","value":"top_articles"},{"text":"Top directory sites (directory_top_sites)","value":"directory_top_sites"},{"text":"Top files (top_files)","value":"top_files"},{"text":"Top image galleries (top_image_galleries)","value":"top_image_galleries"},{"text":"Top users (users_rank)","value":"users_rank"},{"text":"Trackerhelp (trackerhelp)","value":"trackerhelp"},{"text":"Translate Updates (translation)","value":"translation"},{"text":"Unread inter-user messages (messages_unread_messages)","value":"messages_unread_messages"},{"text":"Upcoming events (upcoming_events)","value":"upcoming_events"},{"text":"User Blogs (user_blogs)","value":"user_blogs"},{"text":"User Pages (user_pages)","value":"user_pages"},{"text":"User bookmarks (user_bookmarks)","value":"user_bookmarks"},{"text":"User image galleries (user_image_galleries)","value":"user_image_galleries"},{"text":"User preferred tags (freetags_prefered)","value":"freetags_prefered"},{"text":"User tasks (user_tasks)","value":"user_tasks"},{"text":"User-Group Tracker (usergroup_tracker)","value":"usergroup_tracker"},{"text":"Waiting Submissions (num_submissions)","value":"num_submissions"},{"text":"Webmail Inbox (webmail_inbox)","value":"webmail_inbox"},{"text":"What is related (whats_related)","value":"whats_related"},{"text":"YouTube (youtube)","value":"youtube"},{"text":"last_youtube_playlist_videos (last_youtube_playlist_videos)","value":"last_youtube_playlist_videos"},{"text":"pagename (pagename)","value":"pagename"},{"text":"toolbox (toolbox)","value":"toolbox"}]},"float":{"required":false,"name":"Float","description":"Align the module to the left or right on the page allowing other elements to align against it","default":"nofloat","advanced":true,"options":[{"text":"No Float","value":""},{"text":"Left","value":"left"},{"text":"Right","value":"right"}]},"decoration":{"required":false,"name":"Decoration","description":"Show box decorations (default is to show them)","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}]},"flip":{"required":false,"name":"Flip","description":"Add ability to show\/hide the content of the module (default is the site admin setting for modules)","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}],"advanced":true},"max":{"required":false,"name":"Max","description":"Number of rows (default: 10)","default":10,"advanced":true},"np":{"required":false,"name":"Parse","description":"Parse wiki syntax (default is to parse)","default":"1","options":[{"text":"","value":""},{"text":"Yes","value":"1"},{"text":"No","value":"0"}],"advanced":true},"notitle":{"required":false,"name":"Title","description":"Show\/hide module title (default is to show the title)","options":[{"text":"","value":""},{"text":"Show title","value":"n"},{"text":"Hide title","value":"y"}]}}};
tiki_plugins.mono = {"name":"Monospace","documentation":"PluginMono","description":"Displays the data using a monospace font","prefs":["wikiplugin_mono"],"body":"text","params":{"font":{"required":false,"name":"Font","description":"Font name as known in browsers.","default":"monospace"}}};
tiki_plugins.mouseover = {"name":"Mouseover","documentation":"PluginMouseover","description":"Create a mouseover feature on some text","prefs":["wikiplugin_mouseover"],"body":"Mouseover text if param label exists. Page text if text param exists","icon":"pics\/icons\/comment_add.png","params":{"label":{"required":true,"name":"Label","description":"Text displayed on the page. The body is the mouseover content","filter":"striptags","default":""},"url":{"required":false,"name":"URL","description":"Destination link when mouseover text is clicked. Use http:\/\/ for external links","filter":"url","default":"javascript:void(0)"},"text":{"required":false,"name":"Text","description":"DEPRECATED Text displayed on the mouseover. The body contains the text of the page.","filter":"striptags","default":"","advanced":true},"width":{"required":false,"name":"Width","description":"Mouseover box width. Default: 400px","filter":"digits","default":400,"advanced":true},"height":{"required":false,"name":"Height","description":"Mouseover box height. Default: 200px","filter":"digits","default":200,"advanced":true},"offsetx":{"required":false,"name":"Offset X","description":"Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5","filter":"digits","default":5,"advanced":true},"offsety":{"required":false,"name":"Offset Y","description":"Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0","filter":"digits","default":0,"advanced":true},"parse":{"required":false,"name":"Parse Body","description":"Parse the body of the plugin as wiki content (parsed by default)","filter":"alpha","advanced":true,"default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"parselabel":{"required":false,"name":"Parse Label","description":"Parse the label as wiki content (parsed by default)","filter":"alpha","default":"y","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"class":{"required":false,"name":"CSS Class","description":"CSS class to apply","filter":"alpha","default":"plugin-mouseover","advanced":true},"bgcolor":{"required":false,"name":"Background Color","description":"Background color to apply to the popup","filter":"striptags","default":"","advanced":true},"textcolor":{"required":false,"name":"Text Color","description":"Color to apply to the text in the popup","filter":"striptags","default":"","advanced":true},"sticky":{"required":false,"name":"Sticky","description":"When enabled, popup stays visible until it is clicked.","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}],"advanced":true},"padding":{"required":false,"name":"Padding","description":"Padding size in pixels","filter":"digits","default":"","advanced":true},"effect":{"required":false,"name":"Effect","options":[{"text":"Default","value":""},{"text":"None","value":"none"},{"text":"Slide","value":"slide"},{"text":"Fade","value":"fade"},{"text":"Blind (UI)","value":"blind_ui"},{"text":"Clip (UI)","value":"clip_ui"},{"text":"Drop (UI)","value":"drop_ui"},{"text":"Explode (UI)","value":"explode_ui"},{"text":"Fold (UI)","value":"fold_ui"},{"text":"Puff (UI)","value":"puff_ui"},{"text":"Slide (UI)","value":"slide_ui"}],"description":"Set the type of show\/hide animation that will be used","filter":"striptags","advanced":true},"speed":{"required":false,"name":"Effect Speed","options":[{"text":"Normal","value":""},{"text":"Fast","value":"fast"},{"text":"Slow","value":"slow"}],"description":"Set the speed of the animation.","filter":"alpha","default":"","advanced":true},"closeDelay":{"required":false,"name":"Close Delay","description":"Number of seconds before popup closes","filter":"digits","default":0,"advanced":true}}};
tiki_plugins.mwtable = {"name":"MWTable","documentation":"PluginMWTable","description":"Displays a table using MediaWiki syntax (experimental - may change in future versions)","prefs":["wikiplugin_mwtable"],"body":"URL","validate":"all","params":{"fancy":{"safe":true,"required":false,"name":"Fancy","description":"Set to true to apply additional formatting to the table (header style, odd\/even rows, etc.)","default":"false","options":[{"text":"","value":""},{"text":"True","value":"true"},{"text":"False","value":"false"}]},"wiki_classes":{"safe":true,"required":false,"name":"Wiki Classes","description":"Determines whether wiki style classes will be used for the table and cells (used by default)","default":"true","options":[{"text":"","value":""},{"text":"True","value":"true"},{"text":"False","value":"false"}]}}};
tiki_plugins.myspace = {"name":"MySpace","documentation":"PluginMySpace","description":"Displays a MySpace Flash mp3 playlist in the wiki page","prefs":["wikiplugin_myspace"],"params":{"page":{"required":true,"name":"MySpace Page","description":"MySpace page name.","default":""}}};
tiki_plugins.objecthits = {"name":"Object Hits","documentation":"PluginObjectHits","description":"Displays object hit info by object and days","prefs":["wikiplugin_objecthits"],"params":{"object":{"required":false,"name":"Object","description":"For a wiki page, the page name, for other object types: ID number + ? + object title","default":""},"type":{"required":false,"name":"Type","description":"Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\".","filter":"alpha","default":"wiki"},"days":{"required":false,"name":"Days","description":"Show the number of hits over the past number of days indicated. Default is to show all hits.","default":0}}};
tiki_plugins.payment = {"name":"Payment","description":"Display a payment request's details based on the user's privileges and the state of the payment. The payment details may include the payment options.","prefs":["wikiplugin_payment","payment_feature"],"params":{"id":{"required":true,"name":"Payment Request Number","description":"Unique identifier of the payment request","filter":"digits","default":""}}};
tiki_plugins.perm = {"name":"Permissions","documentation":"PluginPerm","description":"Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms).","body":"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met.","prefs":["wikiplugin_perm"],"filter":"wikicontent","params":{"perms":{"required":false,"name":"Possible Permissions","description":"Pipe separated list of permissions, one of which is needed to view the default text. Example:tiki_p_rename|tiki_p_edit","default":""},"notperms":{"required":false,"name":"Forbidden Permissions","description":"Pipe separated list of permissions, any of which will cause the default text not to show. Example:tiki_p_rename|tiki_p_edit","default":""}}};
tiki_plugins.pluginmanager = {"name":"Plugin Manager","documentation":"PluginPluginManager","description":"Displays a list of plugins or modules available in this wiki.","prefs":["wikiplugin_pluginmanager"],"introduced":3,"params":{"info":{"required":false,"name":"Information","description":"Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none.","filter":"striptags","accepted":"One or more of: description | parameters | paraminfo","default":"description | parameters | paraminfo ","since":"","options":[{"text":"","value":""},{"text":"Description","value":"description"},{"text":"Description & Parameters","value":"description|parameters"},{"text":"Description & Parameter Info","value":"description|paraminfo"},{"text":"Parameters & Parameter Info","value":"parameters|paraminfo"},{"text":"All","value":"description|parameters|paraminfo"}]},"plugin":{"required":false,"name":"Plugin","description":"Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter.","filter":"striptags","default":"","since":"5.0"},"module":{"required":false,"name":"Module","description":"Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter.","filter":"striptags","default":"","since":"6.1"},"singletitle":{"required":false,"name":"Single Title","description":"Set placement of plugin name and description when displaying information for only one plugin","filter":"alpha","default":"none","since":"5.0","options":[{"text":"","value":""},{"text":"Top","value":"top"},{"text":"Table","value":"table"}]},"titletag":{"required":false,"name":"Title Heading","description":"Sets the heading size for the title, e.g., h2.","filter":"striptags","default":"h3","since":"5.0"},"start":{"required":false,"name":"Start","description":"Start with this plugin record number (must be an integer 1 or greater).","filter":"digits","default":"","since":"5.0"},"limit":{"required":false,"name":"Limit","description":"Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater.","filter":"digits","default":"","since":"5.0"}}};
tiki_plugins.poll = {"name":"Poll","documentation":"PluginPoll","description":"Displays the output of a poll, fields are indicated with numeric ids.","prefs":["feature_polls","wikiplugin_poll"],"body":"Title","params":{"pollId":{"required":true,"name":"Poll","description":"Numeric value representing the poll ID","default":""},"showtitle":{"required":false,"name":"Show Title","description":"Show poll title (shown by default).","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.profile = {"name":"Profile application","description":"Adds controls required to apply a profile.","documentation":"PluginProfile","prefs":["wikiplugin_profile"],"validate":"all","inline":true,"params":{"domain":{"required":false,"name":"Domain","description":"Profile repository domain. Default value is profiles.tiki.org","default":"profiles.tiki.org"},"name":{"required":true,"name":"Profile Name","description":"Name of the profile to be applied.","default":""}}};
tiki_plugins.proposal = {"name":"Proposal","documentation":"PluginProposal","description":"Provides a widget for users to vote on a proposal and view the current decision.","prefs":["wikiplugin_proposal"],"body":"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username.","params":{"caption":{"required":false,"name":"Caption","description":"Short description of the proposal to vote on. Will be displayed above the result table.","default":""}}};
tiki_plugins.quote = {"name":"Quote","documentation":"PluginQuote","description":"Quote text by surrounding the text with a box, like the [QUOTE] BBCode","prefs":["wikiplugin_quote"],"body":"Quoted text","icon":"pics\/icons\/quotes.png","filter":"text","params":{"replyto":{"required":false,"name":"Reply To","description":"Name of the quoted person.","filter":"text","default":""}}};
tiki_plugins.randominclude = {"name":"RandomInclude","documentation":"PluginRandomInclude","description":"Include a random page's content.","prefs":["wikiplugin_randominclude"],"params":[]};
tiki_plugins.rcontent = {"name":"Random Dynamic Content","documentation":"PluginRcontent","description":"Includes random content from the dynamic content system.","prefs":["feature_dynamic_content","wikiplugin_rcontent"],"params":{"id":{"required":true,"name":"Content ID","description":"Numeric value representing the content ID","default":""}}};
tiki_plugins.realnamelist = {"name":"User List (showing Real Name)","documentation":"PluginRealNameList","description":"Displays a list of registered users showing their Real Names (experimental, should be merged with UserList in Tiki5)","prefs":["wikiplugin_realnamelist"],"body":"Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included.","params":{"sep":{"required":false,"name":"Separator","description":"String to use between elements of the list if table layout is not used","default":", "},"max":{"required":false,"name":"Maximum","description":"Result limit","default":-1},"sort":{"required":false,"name":"Sort Order","description":"Set to sort in ascending or descending order (unsorted by default","default":"","options":[{"text":"","value":""},{"text":"Ascending","value":"asc"},{"text":"Descending","value":"desc"}]},"layout":{"required":false,"name":"Layout","description":"Set to table to show results in a table (not shown in a table by default)","default":"","options":[{"text":"","value":""},{"text":"Table","value":"table"}]},"link":{"required":false,"name":"Link","description":"Make the listed names links to various types of user information","default":"","options":[{"text":"","value":""},{"text":"User Information","value":"userinfo"},{"text":"User Page","value":"userpage"},{"text":"User Preferences","value":"userpref"}]},"exclude":{"required":false,"name":"Exclude","description":"Exclude certain test or admin names from the list","default":"","options":[{"text":"","value":""},{"text":"admin","value":"admin"},{"text":"admin-test","value":"admin-test"},{"text":"test","value":"test"},{"text":"test-admin","value":"test-admin"}]}}};
tiki_plugins.redirect = {"name":"Redirect","documentation":"PluginRedirect","description":"Redirect the user to a wiki page or generic URL.","prefs":["wikiplugin_redirect"],"validate":"arguments","params":{"page":{"required":false,"name":"Page Name","description":"Wiki page name to redirect to.","default":""},"url":{"required":false,"name":"URL","description":"Complete URL, internal or external.","default":""}}};
tiki_plugins.regex = {"name":"Regular Expression","documentation":"PluginRegex","validate":"all","description":"Takes regex expressions and parses the content between REGEX tags and replaces the text.","prefs":["wikiplugin_regex"],"body":"Each line of content is evaluated separately","params":{"pageName":{"required":true,"name":"Page name","description":"Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: \/search pattern\/::replacement text","default":"pageName"}}};
tiki_plugins.remarksbox = {"name":"Remarks Box","documentation":"PluginRemarksBox","description":"Displays a comment, tip, note or warning box","prefs":["wikiplugin_remarksbox"],"body":"remarks text","params":{"type":{"required":true,"name":"Type","description":"Select type of remarksbox, which determines what icon and style will be displayed","default":"tip","options":[{"text":"","value":""},{"text":"Comment","value":"comment"},{"text":"Confirm","value":"confirm"},{"text":"Errors","value":"errors"},{"text":"Information","value":"information"},{"text":"Note","value":"note"},{"text":"Tip","value":"tip"},{"text":"Warning","value":"warning"}]},"title":{"required":true,"name":"Title","description":"Label displayed above the remark.","default":""},"highlight":{"required":false,"name":"Highlight","description":"Use the highlight class for formatting (not used by default).","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"icon":{"required":false,"name":"Custom Icon","description":"Enter a Tiki icon file name (with or without extension) or path to display a custom icon","default":""},"close":{"required":false,"name":"Close","description":"Show a close button (not shown by default).","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"width":{"required":false,"name":"Width","description":"Width (e.g. 100% or 250px - default \"\")","default":""}}};
tiki_plugins.rss = {"name":"RSS Feed","documentation":"PluginRSS","description":"Inserts an RSS feed output.","prefs":["wikiplugin_rss"],"icon":"pics\/icons\/rss.png","format":"html","filter":"striptags","params":{"id":{"required":true,"name":"IDs","separator":":","filter":"int","description":"List of feed IDs separated by colons. ex: feedId:feedId2","default":""},"max":{"required":false,"name":"Result Count","filter":"int","description":"Number of results displayed.","default":10},"date":{"required":false,"name":"Date","filter":"int","description":"Show date of each item (not shown by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"desc":{"required":false,"name":"Description","filter":"int","description":"Show feed descriptions (not shown by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"author":{"required":false,"name":"Author","filter":"int","description":"Show authors (not shown by default)","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"icon":{"required":false,"name":"Icon","filter":"url","description":"Url to a favicon to put before each entry","default":""},"showtitle":{"required":false,"name":"Show Title","filter":"int","description":"Show the title of the feed (shown by default)","default":1,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.scroll = {"name":"Scroll","documentation":"PluginScroll","description":"","prefs":["wikiplugin_scroll"],"body":"text","params":{"width":{"required":true,"name":"Width","description":"Width in pixels. Example: 600px.","accepted":"Number of pixels followed by \"px\". Example: 600px.","filter":"striptags","default":""},"height":{"required":true,"name":"Height","description":"Height in pixels. Example: 450px","accepted":"Number of pixels followed by \"px\". Example: 450px.","filter":"striptags","default":""},"speed":{"required":false,"name":"Speed","description":"Scroll speed in number of seconds (default is 8 seconds)","filter":"int","default":8}}};
tiki_plugins.sf = {"name":"SourceForge","documentation":"PluginSF","description":"Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text.","prefs":["wikiplugin_sf"],"body":"text","params":{"groupid":{"required":true,"name":"Group ID","description":"SourceForge project ID (shows as group_id in the url of a tracker item","filter":"digits","default":""},"trackerid":{"required":true,"name":"Tracker ID","description":"SourceForge tracker ID (shows as atid in the url of a tracker item","filter":"digits","default":""},"itemid":{"required":true,"name":"Item ID","description":"SourceForge item ID (shows as aid in the url of a tracker item","filter":"digits","default":""},"title":{"required":false,"name":"Link title","description":"First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request).","filter":"alpha","default":"Item","since":7}}};
tiki_plugins.sharethis = {"name":"Sharethis","documentation":"PluginSharethis","description":"Display a social networking tool.","prefs":["wikiplugin_sharethis"],"params":{"sendsvcs":{"required":false,"name":"Send Services","description":"By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services.","default":"","advanced":true,"options":[{"text":"","value":""},{"text":"Aim","value":"aim"},{"text":"Aim $ Email","value":"aim|email"},{"text":"Aim $ Sms","value":"aim|sms"},{"text":"Email","value":"email"},{"text":"Email $ Sms","value":"email|sms"}]},"style":{"required":false,"name":"Button Style","description":"Set button style: horizontal, vertical or rotate.","default":"","options":[{"text":"","value":""},{"text":"Horizontal","value":"horizontal"},{"text":"Vertical","value":"vertical"},{"text":"Rotate","value":"rotate"}]},"rotateimage":{"required":false,"name":"Rotate Image","description":"A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping.","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"multiple":{"required":false,"name":"Multiple Icons","description":"Enter list: email | facebook | twitter | sharethis, depending on which icons you'd like.","default":""},"postfirst":{"required":false,"name":"First Services Shown","description":"Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget.","filter":"alpha","advanced":true,"default":""},"buttontext":{"required":false,"name":"Button Text","description":"Custom link text for the button.","default":""},"headertitle":{"required":false,"name":"Header Title","description":"Optional header title text for the widget.","default":""},"headerbg":{"required":false,"name":"Header Background","description":"HTML color code (not color name) for the background color for the header if an optional header title is used.","advanced":true,"default":""},"headertxtcolor":{"required":false,"name":"Header Text Color","description":"HTML color code (not color name) for the header text if an optional header title is used.","advanced":true,"default":""},"linkfg":{"required":false,"name":"Link text color for services","description":"HTML color code (not color name) for the link text for all send and post services shown in the widget","advanced":true,"default":""},"popup":{"required":false,"name":"Pop-up","description":"A value of true will cause the widget to show in a pop-up window.","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"True","value":"true"}]},"embed":{"required":false,"name":"Embedded Elements","description":"A value of true will allow embedded elements (like flash) to be seen while iframe is loading.","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"True","value":"true"}]}}};
tiki_plugins.sheet = {"name":"Sheet","documentation":"PluginSheet","description":"Displays the content of a spreadsheet in the page.","prefs":["wikiplugin_sheet","feature_sheet"],"body":"Sheet Heading","params":{"id":{"required":false,"name":"Sheet ID","description":"Internal ID of the TikiSheet.  Either id or url MUST be used.","filter":"digits","accepted":"Sheet ID number","default":"","since":""},"url":{"required":false,"name":"Sheet Url Location","description":"Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used.","filter":"url","accepted":"Valid url","default":"","since":"6.0"},"simple":{"required":false,"name":"Simple","description":"Simple table view y\/n (Default: n = jquery.sheet view if feature enabled).","filter":"alpha","accepted":"y or n","default":"n","since":"5.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"width":{"required":false,"name":"Width","description":"Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"","filter":"striptags","accepted":"Number of pixels followed by 'px' or percent followed by % (e.g. \"200px\" or \"100%\").","default":"Page width","since":"6.0"},"height":{"required":false,"name":"Height","description":"Height in pixels or percentage. Default value is complete spreadsheet height.","filter":"striptags","accepted":"Number of pixels followed by 'px' or percent followed by % (e.g. \"200px\" or \"100%\").","default":"Spreadsheet heigth","since":"5.0"},"editable":{"required":false,"name":"Editable","description":"Show edit button. Default 'y' depending on user's permissions.","filter":"alpha","accepted":"y or n","default":"y","since":"6.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"subsheets":{"required":false,"name":"Show subsheets","description":"y\/n. Show multi-sheets. Default 'y'.","filter":"alpha","accepted":"y or n","default":"y","since":"6.0","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"range":{"required":false,"name":"Range","description":"Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"","filter":"striptags","accepted":"Cell range, e.g. \"D1:F3\" or \"e14:e14\"","default":"All cells","since":"6.0"},"class":{"required":false,"name":"CSS Class","description":"Apply custom CSS class to the containing div.","filter":"text","accepted":"Any valid CSS class","default":"","since":"6.0"}}};
tiki_plugins.showpages = {"name":"Show Pages","documentation":"PluginShowPages","description":"List wiki pages","prefs":["wikiplugin_showpages"],"params":{"find":{"required":true,"name":"Find","description":"Search criteria","default":""},"max":{"required":false,"name":"Result Count","description":"Maximum amount of results displayed.","filter":"digits","default":""},"display":{"required":false,"name":"Display","description":"Display page name and\/or description. Both displayed by default.","filter":"striptags","default":"name|desc","options":[{"text":"","value":""},{"text":"Name","value":"name"},{"text":"Description","value":"desc"},{"text":"Name & Description","value":"name|desc"}]}}};
tiki_plugins.skype = {"name":"Skype","documentation":"PluginSkype","description":"Clickable Skype link","prefs":["wikiplugin_skype"],"body":"Name or number to call or chat with.","params":{"action":{"required":false,"name":"Action","description":"Set whether to call or chat. Default is chat","default":"chat","options":[{"text":"","value":""},{"text":"Call","value":"call"},{"text":"Chat","value":"chat"}]}}};
tiki_plugins.smarty = {"name":"Smarty function","documentation":"PluginSmarty","description":"Provides access to the tiki smarty functions like button.","prefs":["wikiplugin_smarty"],"validate":"all","extraparams":true,"params":{"name":{"required":false,"name":"Smarty Function","description":"The name of the smarty function that the button will activate. Available functions are: lib\/smarty\/libs\/plugins\/function.[name].php","filter":"word","default":""}}};
tiki_plugins.snarf = {"name":"Snarf","documentation":"PluginSnarf","description":"Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified.","prefs":["wikiplugin_snarf"],"validate":"all","params":{"url":{"required":true,"name":"URL","description":"Full URL to the page to include.","filter":"url","default":""},"regex":{"required":false,"name":"Regular Expression Pattern","description":"PCRE-compliant regular expression pattern to find the parts you want changed","default":"","filter":"striptags"},"regexres":{"required":false,"name":"Regular Expression Replacement","description":"PCRE-compliant regular expression replacement syntax showing what the content should be changed to","default":"","filter":"striptags"},"wrap":{"required":false,"name":"Word Wrap","description":"Enable\/disable word wrapping of snippets of code (enabled by default)","default":1,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"filter":"int"},"colors":{"required":false,"name":"Colors","description":"Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ...","default":null,"filter":"striptags"},"ln":{"required":false,"name":"Line Numbers","description":"Set to 1 (Yes) to add line numbers to code snippets (not shown by default)","default":null,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"filter":"int"},"wiki":{"required":false,"name":"Wiki Syntax","description":"Parse wiki syntax within the code snippet (not parsed by default).","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"filter":"int"},"rtl":{"required":false,"name":"Right to Left","description":"Switch the text display from left to right to right to left","default":null,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"filter":"int"},"ishtml":{"required":false,"name":"HTML Content","description":"Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default).","default":null,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}],"filter":"int"},"cache":{"required":false,"name":"Cache Url","description":"Cache time in minutes. Default is to use site preference, Set to 0 for no cache.","default":"","filter":"int"},"ajax":{"required":false,"name":"Label","description":"Text to click on to fetch the url via ajax","default":"","filter":"striptags"}}};
tiki_plugins.sort = {"name":"Sort","documentation":"PluginSort","description":"Sorts the plugin content in the wiki page","prefs":["wikiplugin_sort"],"body":"Data to sort, one entry per line.","filter":"text","params":{"sort":{"required":false,"name":"Order","description":"Set the sort order of lines of content (default is ascending)","filter":"alpha","default":"asc","options":[{"text":"","value":""},{"text":"Ascending","value":"asc"},{"text":"Descending","value":"desc"},{"text":"Reverse","value":"reverse"},{"text":"Shuffle","value":"shuffle"}]}}};
tiki_plugins.split = {"name":"Split","documentation":"PluginSplit","description":"Split a page into rows and columns","prefs":["wikiplugin_split"],"filter":"wikicontent","params":{"joincols":{"required":false,"name":"Join Columns","description":"Generate the colspan attribute if columns are missing","filter":"striptags","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"fixedsize":{"required":false,"name":"Fixed Size","description":"Generate the width attribute for the columns","filter":"striptags","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"colsize":{"required":false,"name":"Column Sizes","description":"Specify all column widths in number of pixels or percent, separating each width by a pipe (|)","default":""},"first":{"required":false,"name":"First","description":"Cells specified are ordered first left to right across rows (default) or top to bottom down columns","filter":"alpha","default":"line","options":[{"text":"","value":""},{"text":"Column","value":"col"},{"text":"Line","value":"line"}]},"edit":{"required":false,"name":"Editable","description":"Display edit icon for each section","filter":"striptags","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"customclass":{"required":false,"name":"Custom Class","description":"Add a class to customize the design","default":""}}};
tiki_plugins.sql = {"name":"SQL","documentation":"PluginSQL","description":"Run an SQL query on a database","prefs":["wikiplugin_sql"],"body":"The SQL query goes in the body. Example: SELECT column1, column2 FROM table","validate":"all","params":{"db":{"required":true,"name":"DSN Name","description":"DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php","default":""}}};
tiki_plugins.stat = {"name":"Stat","documentation":"PluginStat","description":"Displays statistics for articles, wiki pages and tracker items","prefs":["wikiplugin_stat"],"params":{"type":{"required":true,"name":"Object Type","description":"Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons.","filter":"striptags","default":"","options":[{"text":"","value":""},{"text":"Article","value":"article"},{"text":"Article & Tracker Item","value":"article:trackeritem"},{"text":"Article & Tracker Item & Wiki","value":"article:trackeritem:wiki"},{"text":"Article & Wiki","value":"article:wiki"},{"text":"Article & Wiki & Tracker Item","value":"article:wiki:trackeritem"},{"text":"Tracker Item","value":"trackeritem"},{"text":"Tracker Item & Article","value":"trackeritem:article"},{"text":"Tracker Item & Article & Wiki","value":"trackeritem:article:wiki"},{"text":"Tracker Item & Wiki","value":"trackeritem:wiki"},{"text":"Tracker Item & Wiki & Article","value":"trackeritem:wiki:article"},{"text":"Wiki","value":"wiki"},{"text":"Wiki & Article","value":"wiki:article"},{"text":"Wiki & Article & Tracker Item","value":"wiki:article:trackeritem"},{"text":"Wiki & Tracker Item","value":"wiki:trackeritem"},{"text":"Wiki & Tracker Item & Article","value":"wiki:trackeritem:article"}]},"parentId":{"required":false,"name":"Parent ID","description":"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)."},"lastday":{"required":false,"name":"Last 24 Hours","description":"Added and\/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"day":{"required":false,"name":"Today","description":"Added and\/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"lastweek":{"required":false,"name":"Last 7 Days","description":"Added and\/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"week":{"required":false,"name":"This Week","description":"Added and\/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"lastmonth":{"required":false,"name":"Last Month","description":"Added and\/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"month":{"required":false,"name":"This Month","description":"Added and\/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"lastyear":{"required":false,"name":"Last Year","description":"Added and\/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]},"year":{"required":false,"name":"This Year","description":"Added and\/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)","filter":"striptags","accepted":"a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"","default":"","options":[{"text":"","value":""},{"text":"Added","value":"a"},{"text":"Added and Viewed","value":"a:v"},{"text":"Viewed","value":"v"},{"text":"Viewed & Added","value":"v:a"}]}}};
tiki_plugins.sub = {"name":"Subscript","documentation":"PluginSub","description":"Displays text in subscript.","prefs":["wikiplugin_sub"],"body":"text","icon":"pics\/icons\/text_subscript.png","params":[]};
tiki_plugins.subscribegroup = {"name":"Subscribe Group","documentation":"PluginSubscribeGroup","description":"Subscribe or unsubscribe to a group","prefs":["wikiplugin_subscribegroup"],"body":"text displyed before the button","params":{"group":{"required":true,"name":"Group Name","description":"Group name to subscribe to or unsubscribe from","default":""},"subscribe":{"required":false,"name":"Subscribe Text","description":"Subscribe text, containing %s as the placeholder for the group name.","default":"Subscribe%s"},"unsubscribe":{"required":false,"name":"Unsubscribe Text","description":"Unsubscribe text, containing %s as the placeholder for the group name.","default":"Unsubscribe%s"},"subscribe_action":{"required":false,"name":"Subscribe Action","description":"Subscribe button label, containing %s as the placeholder for the group name.","default":"OK"},"unsubscribe_action":{"required":false,"name":"Unsubscribe Action","description":"Unsubscribe button label, containing %s as the placeholder for the group name.","default":"OK"}}};
tiki_plugins.subscribegroups = {"name":"Subscribe Groups","documentation":"PluginSubscribeGroups","description":"Subscribe or unsubscribe to a group","prefs":["wikiplugin_subscribegroups"],"params":{"subscribe":{"required":false,"name":"Subscribe","description":"Text shown in the dropdown box. Default: \"Subscribe to a group\"","default":""},"showsubscribe":{"required":false,"name":"Show Subscribe Box","description":"Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for.","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdefault":{"required":false,"name":"Show Default","description":"Shows which group is the user's default group (if any) and allows the user to change his default group.","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showgroupdescription":{"required":false,"name":"Group Description","description":"Show the description of the group (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"groups":{"required":false,"name":"Groups","description":"Colon separated list of groups. By default the list of groups available to the user.","default":""},"including":{"required":false,"name":"Including Group","description":"All groups including this group will be listed","default":""},"defaulturl":{"required":false,"name":"Default URL","description":"Page user will be directed to after clicking on icon to change default group","default":""}}};
tiki_plugins.subscribenewsletter = {"name":"Subscribe newsletter","documentation":"PluginSubscribeNewsletter","description":"A button to subscribe to a newsletter available for a user if not already in","prefs":["feature_newsletters","wikiplugin_subscribenewsletter"],"body":"Invitation message","params":{"nlId":{"required":true,"name":"Newsletter ID","description":"Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to","filter":"digits","default":""},"thanks":{"required":false,"name":"Confirmation Message","description":"Confirmation message after posting form. The plugin body is then the button label.","filter":"wikicontent"},"button":{"required":false,"name":"Button","description":"Button label. The plugin body is then the confirmation message","filter":"wikicontent"},"wikisyntax":{"required":false,"safe":true,"name":"Wiki Syntax","description":"Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)","filter":"int","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.sup = {"name":"Superscript","documentation":"PluginSup","description":"Displays text in superscript (exponent).","prefs":["wikiplugin_sup"],"body":"text","icon":"pics\/icons\/text_superscript.png","params":[]};
tiki_plugins.survey = {"name":"Survey","documentation":"PluginSurvey","description":"Displays a survey","prefs":["feature_surveys","wikiplugin_survey"],"body":"","params":{"id":{"required":true,"name":"Id","description":"Id","filter":"digits","default":""},"page":{"required":false,"name":"Page","description":"Wiki Page to redirect the user after his vote","default":"tiki-list_surveys.php"},"lang":{"required":false,"name":"Language","description":"Language","filter":"alpha","default":""}}};
tiki_plugins.tabs = {"name":"Tabs","documentation":"PluginTabs","description":"Display page content in a set of tabs","prefs":["wikiplugin_tabs"],"body":"Tabs content separated by \/\/\/\/\/","params":{"name":{"required":false,"name":"Tabset Name","description":"Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs","default":""},"tabs":{"required":true,"name":"Tab Titles","description":"Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3","default":""}}};
tiki_plugins.tag = {"name":"Tag","documentation":"PluginTag","description":"Displays the text between an html tag","prefs":["wikiplugin_tag"],"validate":"all","body":"text","params":{"tag":{"required":false,"name":"Tag Name","description":"Any valid HTML tag, span by default.","default":"span"},"style":{"required":false,"name":"CSS Style","description":"Equivalent to the style attribute of an HTML tag.","default":""}}};
tiki_plugins.titlesearch = {"name":"Title Search","documentation":"PluginTitleSearch","description":"Search wiki page titles.","prefs":["feature_wiki","wikiplugin_titlesearch"],"params":{"search":{"required":true,"name":"Search Criteria","description":"Portion of a page name.","default":""},"info":{"required":false,"name":"Information","description":"Also show page hits or user","default":"","options":[{"text":"","value":""},{"text":"Hits","value":"hits"},{"text":"User","value":"user"}]},"exclude":{"required":false,"name":"Exclude","description":"Pipe-separated list of page names to exclude from results.","default":""},"noheader":{"required":false,"name":"No Header","description":"Set to 1 (Yes) to have no header for the search results.","default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]}}};
tiki_plugins.toc = {"name":"Table of Contents (Structure)","documentation":"PluginTOC","description":"Displays the table of contents for the current structure's subtree as part of the page content.","prefs":["wikiplugin_toc","feature_wiki_structure"],"params":{"maxdepth":{"name":"Maximum Depth","description":"Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default).","required":false,"filter":"digits","default":0},"structId":{"name":"Structure ID","description":"By default, structure for the current page will be displayed. Alternate structure may be provided.","required":false,"filter":"digits","default":""},"order":{"name":"Order","description":"Order items in ascending or descending order (deafult is ascending).","required":false,"filter":"alpha","default":"asc","options":[{"text":"","value":""},{"text":"Ascending","value":"asc"},{"text":"Descending","value":"desc"}]},"showdesc":{"name":"Show Description","description":"Show the page description instead of the page name","required":false,"default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"shownum":{"name":"Show Numbering","description":"Display the section numbers or not","required":false,"default":0,"options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"type":{"name":"Type","description":"Apply the \"plain\" or \"fancy\" style","required":false,"filter":"alpha","default":"plain","options":[{"text":"","value":""},{"text":"Plain","value":"plain"},{"text":"Fancy","value":"fancy"}]},"pagename":{"name":"Page Name","description":"By default, the table of contents for the current page will be displayed. Alternate page may be provided.","required":false,"default":""}}};
tiki_plugins.topfriends = {"name":"Top Friends","documentation":"PluginTopFriends","description":"List top-scoring users.","prefs":["feature_friends","wikiplugin_topfriends"],"params":{"limit":{"required":false,"name":"Limit","description":"Maximum result count.","filter":"digits","default":5},"public":{"required":false,"name":"Public","description":"Set whether public or not.","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.tr = {"name":"Translate","documentation":"PluginTR","description":"Translate a string using Tiki translation table.","prefs":["wikiplugin_tr"],"body":"string","params":[]};
tiki_plugins.tracker = {"name":"Tracker","documentation":"PluginTracker","description":"Displays an input form for tracker submit","prefs":["feature_trackers","wikiplugin_tracker"],"body":"Confirmation message after posting form","icon":"pics\/icons\/database.png","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"fields":{"required":true,"name":"Fields","description":"Colon-separated list of field IDs to be displayed. Example: 2:4:5","default":""},"action":{"required":false,"name":"Action","description":"Label on the submit button. Default is \"Save\".","separator":":","default":"Save"},"showtitle":{"required":false,"name":"Show Title","description":"Display the title of the tracker (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdesc":{"required":false,"name":"Show Description","description":"Show the tracker's description (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showmandatory":{"required":false,"name":"Mark Mandatory","description":"Indicate mandatory fields with an asterisk (shown by default).","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showstatus":{"required":false,"name":"Show Status","description":"Show the status of the items (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"embedded":{"required":false,"name":"Embedded","description":"Embedded","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"email":{"required":false,"name":"Email","description":"To send an email once the tracker item has been created. Format: from|to|template","default":""},"emailformat":{"required":false,"name":"Email format","description":"Text or html setting","default":"text"},"url":{"required":false,"name":"URL","description":"URL the user is sent to after the form is submitted","filter":"url","separator":":","default":""},"target":{"required":false,"name":"Url Target","description":"Set the target parameter for the url (determines whether target will open in a new pge, etc.","default":"","options":[{"text":"","value":""},{"text":"Blank","value":"_blank"},{"text":"Parent","value":"_parent"},{"text":"Self","value":"_self"},{"text":"Top","value":"_top"}]},"values":{"required":false,"name":"Values","description":"Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc.","default":""},"overwrite":{"required":false,"name":"Overwrite","description":"Overwrite current field values of the item with the input values","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"sort":{"required":false,"name":"Sort","description":"Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"preview":{"required":false,"name":"Preview","description":"Label for the preview button. Default: \"Preview\"","default":"Preview"},"reset":{"required":false,"name":"Reset","description":"Label for the reset button, to return all fields to their default values.","default":"reset"},"view":{"required":false,"name":"View","description":"View","default":"","options":[{"text":"","value":""},{"text":"Group","value":"group"},{"text":"Page","value":"page"},{"text":"User","value":"user"}]},"status":{"required":false,"name":"Status","description":"Status of the item used in combination with: view=user","default":""},"itemId":{"required":false,"name":"ItemId","description":"ItemId allowing for editing an item","filter":"digits","default":""},"ignoreRequestItemId":{"required":false,"name":"Ignore ItemId","description":"Do not filter on the parameter itemId if in the url","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"tpl":{"required":false,"name":"Template File","description":"Name of the template used to display the tracker items.","default":""},"wiki":{"required":false,"name":"Wiki","description":"Name of the wiki page containing the template to display the tracker items.","filter":"pagename","default":""},"newstatus":{"required":false,"name":"New Status","description":"Default status applied to newly created items.","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"}]},"colwidth":{"required":false,"name":"Width","description":"Specify the width in pixels or percentage of the first column (the labels) in the tracker form.","default":"","accepted":"## or ##%"},"autosavefields":{"required":false,"name":"Autosave fields","description":"Colon-separated list of field IDs to be automatically filled with values","filter":"digits","separator":":","default":""},"autosavevalues":{"required":false,"name":"Autosavevalue","description":"Colon-separated values corresponding to autosavefields","filter":"text","separator":":","default":""},"registration":{"required":false,"name":"Registration Fields","description":"Add registration fields such as Username and Password","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"outputtowiki":{"required":false,"name":"Output To Wiki","description":"Output result to a new wiki page with the name taken from the input for the specified fieldId","filter":"digits","default":""},"discarditem":{"required":false,"name":"Discard After Output","description":"Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"outputwiki":{"required":false,"name":"Template Page","description":"Name of the wiki page containing the template to format the output to wiki page","filter":"pagename","default":""},"formtag":{"required":false,"name":"Embed the tracker in a form tag","description":"If set to Yes, the tracker is contained in a <form> tag and has action buttons","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.trackercomments = {"name":"Tracker Comments","documentation":"PluginTrackerComments","description":"Displays the number of tracker comments","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"shownbitems":{"required":false,"name":"Item Count","description":"Determines whether the number of items will be shown (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"view":{"required":false,"name":"View","description":"Enter a user name to select the items of the current user","accepted":"a user name","filter":"alpha","default":""}}};
tiki_plugins.trackerfilter = {"name":"Tracker Filter","documentation":"PluginTrackerFilter","description":"Filters the items of a tracker, fields are indicated with numeric ids.","prefs":["feature_trackers","wikiplugin_trackerfilter"],"body":"notice","params":{"filters":{"required":true,"name":"Filters","description":"The list of fields that can be used as filters along with their formats. The field number and format are separated by a \/ \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example:2\/d:4\/r:5:(6:7)\/sqlsearch","default":""},"action":{"required":false,"name":"Action","description":"Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)","default":"Filter"},"displayList":{"required":false,"name":"Display List","description":"Show the full list (before filtering) initially (filtered list shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"line":{"required":false,"name":"Line","description":"Displays all the filters on the same line (not shown on same line by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"noflipflop":{"required":false,"name":"No Toggle","description":"The toggle button to show\/hide filters will not be shown if set to y (Yes). Default is to show the toggle.","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"export_action":{"required":false,"name":"Export CSV.","description":"Label for an export button. Leave blank to show the usual \"Filter\" button instead.","default":"","advanced":true},"googlemapButtons":{"required":false,"name":"Google Map Buttons","description":"Display Mapview and Listview buttons","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"fields":{"required":false,"name":"Fields","description":"Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5","filter":"digits","separator":":","default":""},"sort":{"required":false,"name":"Sort","description":"Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"popup":{"required":false,"name":"Popup","description":"Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7","filter":"digits","separator":":","default":""},"stickypopup":{"required":false,"name":"Sticky Popup","description":"Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showtitle":{"required":false,"name":"Show Title","description":"Display the title of the tracker (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlinks":{"required":false,"name":"Show Links","description":"Show links to each tracker item (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdesc":{"required":false,"name":"Show Description","description":"Show the tracker's description (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"shownbitems":{"required":false,"name":"Show Item Count","description":"Show the number of items found (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showinitials":{"required":false,"name":"Show Initials","description":"Show an alphabetical index by first letter to assist in navigation (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showstatus":{"required":false,"name":"Show Status","description":"Show the status of the items (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showcreated":{"required":false,"name":"Show Creation Date","description":"Creation date display is based on tracker settings unless overriden here","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlastmodif":{"required":false,"name":"Last Modification Date","description":"Last modification date display is based on tracker settings unless overriden here","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfieldname":{"required":false,"name":"Show Field Name","description":"Use the field names as column titles (used by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showitemrank":{"required":false,"name":"Show Item Rank","description":"Show item ranks (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"status":{"required":false,"name":"Status Filter","description":"Only show items matching certain status filters (only items with open status shown by default)","filter":"alpha","default":"o","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"},{"text":"Open & Pending","value":"op"},{"text":"Open & Closed","value":"oc"},{"text":"Pending & Closed","value":"pc"},{"text":"Open, Pending & Closed","value":"opc"}]},"sort_mode":{"required":false,"name":"Sort Mode","description":"Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: created_asc, created_desc, lastModif_asc, lastModif_desc, f_fieldId_asc, f_filedId_desc (replacing fieldId with the field ID number).","filter":"word","default":""},"sortchoice":{"required":false,"name":"Sort Choice","description":"Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first","filter":"text","separator":":","default":""},"max":{"required":false,"name":"Maximum Items","description":"Maximum number of items to display. Defaults to max records preference, if set.","filter":"int","default":""},"offset":{"required":false,"name":"Offset","description":"Offset of first item. Default is no offset.","filter":"int","default":0},"showpagination":{"required":false,"name":"Show Pagination","description":"Determines whether pagination will be shown (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"filterfield":{"required":false,"name":"Filter Field","description":"Colon separated list of fields to allow filtering on.","filter":"digits","separator":":","default":""},"filtervalue":{"required":false,"name":"Filter Value","description":"Filter value of the filterfield. For better performance, use exactvalue instead","filter":"text","separator":":","default":""},"exactvalue":{"required":false,"name":"Exact Value","description":"Exact value of the filter","filter":"text","separator":":","default":""},"checkbox":{"required":false,"name":"Checkbox","description":"Adds a checkbox on each line to be able to do an action.<br \/>e.g. fieldId\/postName\/Title\/Submit\/ActionUrl\/tpl\/radio|dropdown<br \/>","advanced":true,"default":""},"goIfOne":{"required":false,"name":"goIfOne","description":"Go directly to tiki-view_tracker_item.php if only one item is found","filter":"alpha","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"more":{"required":false,"name":"More","description":"Show a 'more' button that links to tiki-view_tracker.php (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"moreurl":{"required":false,"name":"More URL","description":"More link pointing to specified URL instead of default tracker item link","filter":"url","default":"tiki-view_tracker.php"},"view":{"required":false,"name":"View","description":"Display only the items of the current user or the current page name","filter":"alpha","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"Page","value":"page"},{"text":"User","value":"user"}]},"tpl":{"required":false,"name":"Template File","description":"Use content of the tpl file as template to display the item","advanced":true,"default":""},"wiki":{"required":false,"name":"Wiki Page","description":"Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins","filter":"pagename","advanced":true,"default":""},"view_user":{"required":false,"name":"View User","description":"Will display the items of the specified user","default":""},"itemId":{"required":false,"name":"Item ID separated with :","description":"To restrict the list to these item IDs","filter":"digits","separator":":","default":""},"ignoreRequestItemId":{"required":false,"name":"Ignore ItemId","description":"Ignore the itemId url parameter when filtering list (not ignored by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"url":{"required":false,"name":"URL","description":"The link that will be on each main field","filter":"url","default":""},"ldelim":{"required":false,"name":"Left Deliminator","description":"Smarty left delimiter for Latex generation","advanced":true,"default":""},"rdelim":{"required":false,"name":"Right Deliminator","description":"Smarty right delimiter for Latex generation","advanced":true,"default":""},"list_mode":{"required":false,"name":"List Mode","description":"Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting.","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"},{"text":"Comma Separated Values","value":"csv"}]},"export":{"required":false,"name":"Export Button","description":"Show an export button (not shown by default)","filter":"alpha","advanced":true,"default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"compute":{"required":false,"name":"Compute","description":"Sum or average all the values of a field and displays it at the bottom of the table. fieldId\/sum:fieldId\/avg","filter":"text","advanced":true,"default":""},"silent":{"required":false,"name":"Silent","description":"Show nothing if no items found (the table header and a 'No records found' message is shown by default).","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdelete":{"required":false,"name":"Show Delete","description":"Show a delete option (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showwatch":{"required":false,"name":"Show Watch Button","description":"Show a watch button (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showrss":{"required":false,"name":"Show Feed Button","description":"Show an RSS feed button (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"googlemap":{"required":false,"name":"Show Google Map","description":"Show Google Map of results (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"googlemapicon":{"required":false,"name":"Google Map Icon","description":"Url of default icon to use for markers on the map","filter":"url","default":"","parent":{"name":"googlemap","value":"y"}},"calendarfielddate":{"required":false,"name":"Calendar Field IDs","description":"Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end","separator":":","filter":"digits","default":""},"calendarviewmode":{"required":false,"name":"Calendar View Mode","description":"Calendar view type time span (default is month)","filter":"word","default":"month","options":[{"text":"","value":""},{"text":"Month","value":"month"},{"text":"Bimester","value":"bimester"},{"text":"Trimester","value":"trimester"},{"text":"Quarter","value":"quarter"},{"text":"Semester","value":"semester"},{"text":"Year","value":"year"}]},"calendarstickypopup":{"required":false,"name":"Sticky Popup","description":"Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default.","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"calendarbeginmonth":{"required":false,"name":"Beginning of Month","description":"Set whether calendar will begin at the beginning of the month (does by default).","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"calendarviewnavbar":{"required":false,"name":"Navigation Bar","description":"Show calendar navigation bar (shown by default).","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"},{"text":"Partial","value":"partial"}]},"calendartitle":{"required":false,"name":"Calendar Title","description":"Enter a title to display a calendar title (not set by default)","filter":"text","default":""},"calendardelta":{"required":false,"name":"Calendar Delta","description":"Set the calendar delta that will be shown (not set by default)","filter":"text","default":"","options":[{"text":"","value":""},{"text":"Plus Month","value":"+month"},{"text":"Minus Month","value":"-month"},{"text":"Plus Bimester","value":"+bimester"},{"text":"Minus Bimester","value":"-bimester"}]},"displaysheet":{"required":false,"name":"Display Spreadsheet.","description":"Display tracker as a spreadsheet (not used by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"force_compile":{"required":false,"name":"Force Compile.","description":"Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}},"extraparams":true};
tiki_plugins.trackeritemfield = {"name":"Tracker Item Field","documentation":"PluginTrackerItemField","description":"Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker).","prefs":["wikiplugin_trackeritemfield","feature_trackers"],"body":"Wiki text containing an {ELSE} marker.","icon":"pics\/icons\/database_go.png","params":{"trackerId":{"required":false,"name":"Tracker ID","description":"Numeric value representing the tracker ID.","filter":"digits","default":""},"itemId":{"required":false,"name":"Item ID","description":"Numeric value representing the item ID. Default is the user tracker item for the current user.","filter":"digits","default":""},"fieldId":{"required":false,"name":"Field ID","description":"Numeric value representing the field ID displayed or tested","filter":"digits","default":""},"fields":{"required":false,"name":"Fields","description":"Colon separated list of field IDs. Default is all fields","default":""},"status":{"required":false,"name":"Status","description":"Status of the tracker item","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"},{"text":"Open & Pending","value":"op"},{"text":"Open & Closed","value":"oc"},{"text":"Pending & Closed","value":"pc"},{"text":"Open, Pending & Closed","value":"opc"}]},"test":{"required":false,"name":"Test","description":"Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter.","default":"","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"value":{"required":true,"name":"Value","description":"Value to compare against.","default":""}}};
tiki_plugins.trackerlist = {"name":"Tracker List","documentation":"PluginTrackerList","description":"Displays the output of a tracker content, fields are indicated with numeric ids.","prefs":["feature_trackers","wikiplugin_trackerlist"],"body":"Notice","icon":"pics\/icons\/database_table.png","filter":"text","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"fields":{"required":false,"name":"Fields","description":"Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5","filter":"digits","separator":":","default":""},"sort":{"required":false,"name":"Sort","description":"Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"popup":{"required":false,"name":"Popup","description":"Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7","filter":"digits","separator":":","default":""},"stickypopup":{"required":false,"name":"Sticky Popup","description":"Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showtitle":{"required":false,"name":"Show Title","description":"Display the title of the tracker (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlinks":{"required":false,"name":"Show Links","description":"Show links to each tracker item (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdesc":{"required":false,"name":"Show Description","description":"Show the tracker's description (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"shownbitems":{"required":false,"name":"Show Item Count","description":"Show the number of items found (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showinitials":{"required":false,"name":"Show Initials","description":"Show an alphabetical index by first letter to assist in navigation (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showstatus":{"required":false,"name":"Show Status","description":"Show the status of the items (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showcreated":{"required":false,"name":"Show Creation Date","description":"Creation date display is based on tracker settings unless overriden here","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showlastmodif":{"required":false,"name":"Last Modification Date","description":"Last modification date display is based on tracker settings unless overriden here","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showfieldname":{"required":false,"name":"Show Field Name","description":"Use the field names as column titles (used by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showitemrank":{"required":false,"name":"Show Item Rank","description":"Show item ranks (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"status":{"required":false,"name":"Status Filter","description":"Only show items matching certain status filters (only items with open status shown by default)","filter":"alpha","default":"o","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"},{"text":"Open & Pending","value":"op"},{"text":"Open & Closed","value":"oc"},{"text":"Pending & Closed","value":"pc"},{"text":"Open, Pending & Closed","value":"opc"}]},"sort_mode":{"required":false,"name":"Sort Mode","description":"Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: created_asc, created_desc, lastModif_asc, lastModif_desc, f_fieldId_asc, f_filedId_desc (replacing fieldId with the field ID number).","filter":"word","default":""},"sortchoice":{"required":false,"name":"Sort Choice","description":"Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first","filter":"text","separator":":","default":""},"max":{"required":false,"name":"Maximum Items","description":"Maximum number of items to display. Defaults to max records preference, if set.","filter":"int","default":""},"offset":{"required":false,"name":"Offset","description":"Offset of first item. Default is no offset.","filter":"int","default":0},"showpagination":{"required":false,"name":"Show Pagination","description":"Determines whether pagination will be shown (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"filterfield":{"required":false,"name":"Filter Field","description":"Colon separated list of fields to allow filtering on.","filter":"digits","separator":":","default":""},"filtervalue":{"required":false,"name":"Filter Value","description":"Filter value of the filterfield. For better performance, use exactvalue instead","filter":"text","separator":":","default":""},"exactvalue":{"required":false,"name":"Exact Value","description":"Exact value of the filter","filter":"text","separator":":","default":""},"checkbox":{"required":false,"name":"Checkbox","description":"Adds a checkbox on each line to be able to do an action.<br \/>e.g. fieldId\/postName\/Title\/Submit\/ActionUrl\/tpl\/radio|dropdown<br \/>","advanced":true,"default":""},"goIfOne":{"required":false,"name":"goIfOne","description":"Go directly to tiki-view_tracker_item.php if only one item is found","filter":"alpha","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"more":{"required":false,"name":"More","description":"Show a 'more' button that links to tiki-view_tracker.php (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"moreurl":{"required":false,"name":"More URL","description":"More link pointing to specified URL instead of default tracker item link","filter":"url","default":"tiki-view_tracker.php"},"view":{"required":false,"name":"View","description":"Display only the items of the current user or the current page name","filter":"alpha","advanced":true,"default":"","options":[{"text":"","value":""},{"text":"Page","value":"page"},{"text":"User","value":"user"}]},"tpl":{"required":false,"name":"Template File","description":"Use content of the tpl file as template to display the item","advanced":true,"default":""},"wiki":{"required":false,"name":"Wiki Page","description":"Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins","filter":"pagename","advanced":true,"default":""},"view_user":{"required":false,"name":"View User","description":"Will display the items of the specified user","default":""},"itemId":{"required":false,"name":"Item ID separated with :","description":"To restrict the list to these item IDs","filter":"digits","separator":":","default":""},"ignoreRequestItemId":{"required":false,"name":"Ignore ItemId","description":"Ignore the itemId url parameter when filtering list (not ignored by default)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"url":{"required":false,"name":"URL","description":"The link that will be on each main field","filter":"url","default":""},"ldelim":{"required":false,"name":"Left Deliminator","description":"Smarty left delimiter for Latex generation","advanced":true,"default":""},"rdelim":{"required":false,"name":"Right Deliminator","description":"Smarty right delimiter for Latex generation","advanced":true,"default":""},"list_mode":{"required":false,"name":"List Mode","description":"Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting.","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"},{"text":"Comma Separated Values","value":"csv"}]},"export":{"required":false,"name":"Export Button","description":"Show an export button (not shown by default)","filter":"alpha","advanced":true,"default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"compute":{"required":false,"name":"Compute","description":"Sum or average all the values of a field and displays it at the bottom of the table. fieldId\/sum:fieldId\/avg","filter":"text","advanced":true,"default":""},"silent":{"required":false,"name":"Silent","description":"Show nothing if no items found (the table header and a 'No records found' message is shown by default).","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showdelete":{"required":false,"name":"Show Delete","description":"Show a delete option (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showwatch":{"required":false,"name":"Show Watch Button","description":"Show a watch button (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"showrss":{"required":false,"name":"Show Feed Button","description":"Show an RSS feed button (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"googlemap":{"required":false,"name":"Show Google Map","description":"Show Google Map of results (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"googlemapicon":{"required":false,"name":"Google Map Icon","description":"Url of default icon to use for markers on the map","filter":"url","default":"","parent":{"name":"googlemap","value":"y"}},"calendarfielddate":{"required":false,"name":"Calendar Field IDs","description":"Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end","separator":":","filter":"digits","default":""},"calendarviewmode":{"required":false,"name":"Calendar View Mode","description":"Calendar view type time span (default is month)","filter":"word","default":"month","options":[{"text":"","value":""},{"text":"Month","value":"month"},{"text":"Bimester","value":"bimester"},{"text":"Trimester","value":"trimester"},{"text":"Quarter","value":"quarter"},{"text":"Semester","value":"semester"},{"text":"Year","value":"year"}]},"calendarstickypopup":{"required":false,"name":"Sticky Popup","description":"Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default.","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"calendarbeginmonth":{"required":false,"name":"Beginning of Month","description":"Set whether calendar will begin at the beginning of the month (does by default).","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"calendarviewnavbar":{"required":false,"name":"Navigation Bar","description":"Show calendar navigation bar (shown by default).","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"},{"text":"Partial","value":"partial"}]},"calendartitle":{"required":false,"name":"Calendar Title","description":"Enter a title to display a calendar title (not set by default)","filter":"text","default":""},"calendardelta":{"required":false,"name":"Calendar Delta","description":"Set the calendar delta that will be shown (not set by default)","filter":"text","default":"","options":[{"text":"","value":""},{"text":"Plus Month","value":"+month"},{"text":"Minus Month","value":"-month"},{"text":"Plus Bimester","value":"+bimester"},{"text":"Minus Bimester","value":"-bimester"}]},"displaysheet":{"required":false,"name":"Display Spreadsheet.","description":"Display tracker as a spreadsheet (not used by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"force_compile":{"required":false,"name":"Force Compile.","description":"Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)","filter":"alpha","default":"n","advanced":true,"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]}}};
tiki_plugins.trackerprefill = {"name":"Tracker Prefill","documentation":"PluginTrackerPrefill","description":"Displays a button to link to a page with a tracker plugin with prefilled tracker fields.","prefs":["feature_trackers","wikiplugin_trackerprefill"],"params":{"page":{"required":true,"name":"Page","description":"Tracker Page Name","default":""},"label":{"required":false,"name":"Label","description":"Button Label.","default":""},"urlparams":{"required":false,"name":"URL Parameters","description":"Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q","default":""},"field1":{"required":true,"name":"Field 1","description":"Field ID for the first field","filter":"digits","default":""},"value1":{"required":true,"name":"Value 1","description":"Content that should be used to prefill the field.","default":""},"field2":{"required":false,"name":"Field 2","description":"Field ID for the second field","filter":"digits","default":""},"value2":{"required":false,"name":"Value 2","description":"Content that should be used to prefill the field.","default":""},"field3":{"required":false,"name":"Field 3","description":"Field ID for the third field","filter":"digits","default":""},"value3":{"required":false,"name":"Value 3","description":"Content that should be used to prefill the field.","default":""},"field4":{"required":false,"name":"Field 4","description":"Field ID for the fourth field","filter":"digits","default":""},"value4":{"required":false,"name":"Value 4","description":"Content that should be used to prefill the field.","default":""},"field5":{"required":false,"name":"Field 5","description":"Field ID for the fifth field","filter":"digits","default":""},"value5":{"required":false,"name":"Value 5","description":"Content that should be used to prefill the field.","default":""}}};
tiki_plugins.trackerstat = {"name":"Tracker Stats","documentation":"PluginTrackerStat","description":"Displays some stat of a tracker content, fields are indicated with numeric ids.","prefs":["feature_trackers","wikiplugin_trackerstat"],"body":"Title","icon":"pics\/icons\/database_lightning.png","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"fields":{"required":true,"name":"Fields","description":"Colon-separated list of field IDs to be displayed. Example: 2:4:5","default":""},"show_percent":{"required":false,"name":"Show Percentage","description":"Choose whether to show the percentage of the vote each option received (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_bar":{"required":false,"name":"Show Bar","description":"Choose whether to show a bar representing the number of votes each option received (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"status":{"required":false,"name":"Status Filter","description":"Only show items matching certain status filters","filter":"alpha","default":"o","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"},{"text":"Open & Pending","value":"op"},{"text":"Open & Closed","value":"oc"},{"text":"Pending & Closed","value":"pc"},{"text":"Open, Pending & Closed","value":"opc"}]},"show_link":{"required":false,"name":"Show Link","description":"Show link to tiki-view_tracker","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_lastmodif":{"required":false,"name":"Last Modification Date","description":"Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net\/strftime).","filter":"text","default":"","accepted":"y to use the site setting for short date format. Otherwise, use PHP format (www.php.net\/strftime), Example: \"%A %d of %B, %Y\""}}};
tiki_plugins.trackertimeline = {"name":"Tracker Timeline","documentation":"PluginTrackerTimeline","description":"Timeline view of a tracker, can be used to display event schedules or gantt charts.","prefs":["wikiplugin_trackertimeline","feature_trackers"],"params":{"tracker":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"title":{"required":true,"name":"Title Field","description":"Tracker Field ID containing the item title.","filter":"digits","default":""},"summary":{"required":true,"name":"Summary Field","description":"Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused.","filter":"digits","default":""},"start":{"required":true,"name":"Start Date","description":"Tracker Field ID containing the element start date. The field must be a datetime\/jscalendar field.","filter":"digits","default":""},"end":{"required":true,"name":"End Date","description":"Tracker Field ID containing the element end date. The field must be a datetime\/jscalendar field.","filter":"digits","default":""},"group":{"required":true,"name":"Element Group","description":"Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row.","filter":"digits","default":""},"lower":{"required":true,"name":"Lower Bound","description":"Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format.","filter":"striptags","default":"","accepted":"Date in YYYY-MM-DD HH:mm:ss format"},"upper":{"required":true,"name":"Upper Bound","description":"Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format.","filter":"striptags","default":"","accepted":"Date in YYYY-MM-DD HH:mm:ss format"},"scale1":{"required":false,"name":"Primary Scale Unit","description":"Unit of time to use for the primary scale (default to hour)","filter":"alpha","default":"hour","options":[{"text":"","value":""},{"text":"Hour","value":"hour"},{"text":"Day","value":"day"},{"text":"Week","value":"week"},{"text":"Month","value":"month"},{"text":"Year","value":"year"}]},"scale2":{"required":false,"name":"Secondary Scale Unit","description":"Unit of time to use for the secondary scale (default to empty)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Hour","value":"hour"},{"text":"Day","value":"day"},{"text":"Week","value":"week"},{"text":"Month","value":"month"},{"text":"Year","value":"year"}]},"link_group":{"required":false,"name":"Link Group Name","description":"Convert the group name to a link","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"link_page":{"required":false,"name":"Page Link Field","description":"Tracker Field ID containing the page name for item details.","filter":"digits","default":""}}};
tiki_plugins.trade = {"name":"Trade","documentation":"PluginTrade","description":"Send or receive payments from one member to another. (for cclite only so far, experimental)","validate":"all","prefs":["wikiplugin_trade","payment_feature"],"params":{"price":{"required":true,"name":"Price","description":"Currency depends on the selected registry.","filter":"text","default":""},"registry":{"required":false,"name":"Registry","description":"Registry to trade in. Default: site preference (or first in list when more than one)","filter":"text","default":""},"currency":{"required":false,"name":"Currency","description":"Currency to trade in. Default: Cclite currency preference for registry set above","filter":"text","default":""},"other_user":{"required":false,"name":"Other User","description":"Name of the user to recieve or send the payment. Leave empty to display an input box.","filter":"username","default":""},"wanted":{"required":false,"name":"Mode","description":"Offered or wanted item. Default:Offered","options":[{"text":"","value":""},{"text":"Offered","value":"n"},{"text":"Wanted","value":"y"}],"filter":"alpha","default":"n"},"action":{"required":false,"name":"Button Label","description":"Default:Continue","filter":"text","default":"Continue"},"inputtitle":{"required":false,"name":"Input Title","description":"Title of the input form. Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user. Supports wiki syntax<br \/>Default:\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted","filter":"text","default":""}}};
tiki_plugins.transclude = {"name":"Transclusion","documentation":"PluginTransclusion","description":"Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin.","prefs":["wikiplugin_transclude","feature_wiki"],"extraparams":true,"defaultfilter":"text","params":{"page":{"required":true,"name":"Page Name","description":"Name of the wiki page to use as a template for the values.","default":""}}};
tiki_plugins.translated = {"name":"Translated","documentation":"PluginTranslated","description":"Links to a translated content","prefs":["feature_multilingual","wikiplugin_translated"],"body":"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)","params":{"lang":{"required":true,"name":"Language","description":"Two letter language code of the language, ex: fr","default":""},"flag":{"required":false,"name":"Flag","description":"Country name, ex: France","default":""}}};
tiki_plugins.usercount = {"name":"User Count","documentation":"PluginUserCount","description":"Displays the number of users that are registered or within a group","prefs":["wikiplugin_usercount"],"body":"Group name","icon":"pics\/icons\/group_gear.png","params":[]};
tiki_plugins.userlink = {"name":"Userlink function","documentation":"PluginUserlink","description":"Makes a link to the user information page","prefs":["wikiplugin_userlink"],"params":{"user":{"required":false,"name":"User account name","description":"User account name (which can be an email address)","filter":"xss"}}};
tiki_plugins.userlist = {"name":"User List","documentation":"PluginUserList","description":"Display a list of registered users","prefs":["wikiplugin_userlist"],"body":"Login Filter","icon":"pics\/icons\/group_go.png","params":{"sep":{"required":false,"name":"Separator","description":"Separator to use between users in the list. Default: comma","default":", ","advanced":true},"max":{"required":false,"name":"Maximum","description":"Result limit","default":"","filter":"digits","advanced":true},"sort":{"required":false,"name":"Sort Order","description":"Set to sort in ascending or descending order","default":"","filter":"alpha","options":[{"text":"","value":""},{"text":"Ascending","value":"asc"},{"text":"Descending","value":"desc"}]},"layout":{"required":false,"name":"Layout","description":"Set to table to display results in a table","default":"","filter":"alpha","options":[{"text":"","value":""},{"text":"List","value":""},{"text":"Table","value":"table"}]},"link":{"required":false,"name":"Link","description":"Make the user names listed links to different types of user information","default":"","filter":"alpha","options":[{"text":"","value":""},{"text":"User info","value":"userinfo"},{"text":"User page","value":"userpage"},{"text":"User pref","value":"userpref"}]},"realname":{"required":false,"filter":"alpha","name":"Real Name","description":"Display the user's real name (when available) instead of login name","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":""}]},"group":{"required":false,"name":"Group","description":"Filter on a group","filter":"groupname","default":""}}};
tiki_plugins.userpref = {"name":"Userpref","documentation":"PluginUserpref","description":"Display wiki text if user has a pref set to a value","body":"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition.","prefs":["wikiplugin_userpref"],"filter":"wikicontent","extraparams":true,"params":[]};
tiki_plugins.versions = {"name":"Versions","documentation":"PluginVersions","description":"Split the text in parts visible only under some conditions","prefs":["wikiplugin_versions"],"body":"Block of text separated by ---(version x)--- markers. Text before the first marker is used by default.","params":{"nav":{"required":false,"name":"Navigation","description":"Displays a navigation box that allows users to select a specific version to display.","default":"n","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"title":{"required":false,"name":"Title","description":"Display the current version name as the title. No title shows when nav=>y; otherwise shows by default.","default":"y","filter":"alpha","parent":{"name":"nav","value":"n"},"options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"default":{"required":false,"name":"Default Label","description":"Specifies version label to show when displaying the page for the first time. Default label is 'Default'","default":"Default"}}};
tiki_plugins.vimeo = {"name":"Vimeo","documentation":"PluginVimeo","description":"Display a Vimeo video","prefs":["wikiplugin_vimeo"],"icon":"pics\/icons\/vimeo.png","introduced":6.1,"params":{"url":{"required":true,"name":"URL","description":"Entire URL to the Vimeo video. Example: http:\/\/vimeo.com\/3319966","filter":"url","default":""},"width":{"required":false,"name":"Width","description":"Width in pixels","filter":"digits","default":425},"height":{"required":false,"name":"Height","description":"Height in pixels","filter":"digits","default":350},"quality":{"required":false,"name":"Quality","description":"Quality of the video","filter":"alpha","options":[{"text":"","value":""},{"text":"High","value":"high"},{"text":"Medium","value":"medium"},{"text":"Low","value":"low"}],"default":"high","advanced":true},"allowFullScreen":{"required":false,"name":"Full screen","description":"Expand to full screen","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"true"},{"text":"No","value":"false"}],"default":"","advanced":true}}};
tiki_plugins.vote = {"name":"Vote","documentation":"PluginVote","description":"Displays some stat of a tracker content, fields are indicated with numeric ids.","prefs":["feature_trackers","wikiplugin_vote"],"body":"Title","params":{"trackerId":{"required":true,"name":"Tracker ID","description":"Numeric value representing the tracker ID","filter":"digits","default":""},"fields":{"required":true,"name":"Fields","description":"Colon-separated list of field IDs to be displayed. Example: 2:4:5","default":""},"show_percent":{"required":false,"name":"Show Percentage","description":"Choose whether to show the percentage of the vote each option received (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_bar":{"required":false,"name":"Show Bar","description":"Choose whether to show a bar representing the number of votes each option received (not shown by default)","filter":"alpha","default":"n","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_stat":{"required":false,"name":"Show Stats","description":"Choose whether to show the voting results (shown by default)","filter":"alpha","default":"y","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_stat_only_after":{"required":false,"name":"Show Stats After","description":"Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"show_creator":{"required":false,"name":"Show Creator","description":"Choose whether to display the user name of the creator of the voting tracker (not shown by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}]},"status":{"required":false,"name":"Status Filter","description":"Only show items matching certain status filters","filter":"alpha","default":"o","options":[{"text":"","value":""},{"text":"Open","value":"o"},{"text":"Pending","value":"p"},{"text":"Closed","value":"c"},{"text":"Open & Pending","value":"op"},{"text":"Open & Closed","value":"oc"},{"text":"Pending & Closed","value":"pc"},{"text":"Open, Pending & Closed","value":"opc"}]},"float":{"required":false,"name":"Float","description":"Align the plugin on the page, allowing other elements to wrap around it (not set by default)","filter":"alpha","default":"","options":[{"text":"","value":""},{"text":"Left","value":"left"},{"text":"Right","value":"right"},{"text":"None","value":"none"}]}}};
tiki_plugins.wantedpages = {"name":"Wanted Pages","documentation":"PluginWantedPages","description":"Lists ''wanted'' wiki pages","prefs":["wikiplugin_wantedpages"],"body":"Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE).","params":{"ignore":{"required":false,"name":"Ignore","description":"A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)","accepted":"a valid regex-expression (PCRE)","default":"","advanced":true},"splitby":{"required":false,"name":"Split By","description":"The character by which ignored patterns are separated.","default":"+","advanced":true},"skipext":{"required":false,"name":"Skip Extension","description":"Whether to include external wikis in the list (not included by default)","default":0,"filter":"digits","options":[{"text":"","value":""},{"text":"Yes","value":1},{"text":"No","value":0}]},"collect":{"required":false,"name":"Collect","description":"Collect either originating (from) or wanted pages (to) in a cell and display them in the second column.","default":"from","filter":"alpha","options":[{"text":"","value":""},{"text":"From","value":"from"},{"text":"To","value":"to"}]},"debug":{"required":false,"name":"Debug","description":"Switch on debug output with details about the items (debug not on by default)","default":0,"filter":"digits","advanced":true,"options":[{"text":"","value":""},{"text":"No","value":0},{"text":"Yes","value":1},{"text":"Memory Saver","value":2}]},"table":{"required":false,"name":"Table","description":"Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell.","filter":"alpha","default":"sep","accepted":"sep, co, br","options":[{"text":"","value":""},{"text":"Comma","value":"co"},{"text":"Line break","value":"br"},{"text":"Separate Row","value":"sep"}]},"level":{"required":false,"name":"Level","description":"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex.","default":"","advanced":true,"options":[{"text":"","value":""},{"text":"Custom","value":"custom"},{"text":"Full","value":"full"},{"text":"Strict","value":"strict"}]}}};
tiki_plugins.watershed = {"name":"Watershed","documentation":"PluginWatershed","description":"Viewer for UStream Watershed Embed.","format":"html","prefs":["wikiplugin_watershed","feature_watershed"],"params":{"type":{"required":false,"name":"Type","description":"Specify archive, broadcaster, chat or viewer","filter":"text","default":"viewer","options":[{"text":"","value":""},{"text":"Archive","value":"archive"},{"text":"Broadcaster","value":"broadcaster"},{"text":"Chat","value":"chat"},{"text":"Viewer","value":"viewer"}]},"channelCode":{"required":true,"name":"Channel code","description":"Specify the channel code to search in the tracker for a channel to use","filter":"text","default":""},"brandId":{"required":false,"name":"Brand ID","description":"Specify the brand id to search in the tracker for a channel to use","filter":"text","default":""},"brandPrefix":{"required":false,"name":"Brand prefix","description":"Copy the prefix from the chat embed, e.g. Name-of-Brand-","filter":"text","default":""},"videoId":{"required":false,"name":"Video ID","description":"Video ID of archive which can be found in the tracker","filter":"text","default":""},"locale":{"required":false,"name":"Locale","description":"Locale specified in viewer embed, default is en_US","default":"en_US","filter":"text"}}};
tiki_plugins.webservice = {"name":"Web Service","documentation":"PluginWebservice","description":"Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface.","prefs":["wikiplugin_webservice"],"body":"Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter.","validate":"all","params":{"url":{"required":false,"name":"URL","description":"Complete service URL","default":""},"service":{"required":false,"safe":true,"name":"Service Name","description":"Registered service name.","default":""},"template":{"required":false,"safe":true,"name":"Template Name","description":"For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided.","default":""},"bodyname":{"required":false,"filter":"word","safe":true,"name":"Body as Parameter","description":"Name of the argument to send the body as for services with complex input. Named service required for this to be useful.","default":""}}};
tiki_plugins.wikipedia = {"name":"Wikipedia","documentation":"PluginWikipedia","description":"Links to a page at Wikipedia","prefs":["wikiplugin_wikipedia"],"body":"","icon":"img\/wiki\/wikipedia.png","params":{"page":{"required":false,"name":"Page","description":"The name of the page to link to. Default is current page."},"lang":{"required":false,"name":"Language","description":"Two character language code. Default is en (English)."},"showprefix":{"required":false,"name":"Show See also prefix","description":"0|1, shows See also prefix"}}};
tiki_plugins.youtube = {"name":"Youtube","documentation":"PluginYouTube","description":"Display youtube video","prefs":["wikiplugin_youtube"],"icon":"pics\/icons\/youtube.png","params":{"movie":{"required":true,"name":"Movie","description":"Entire URL to the YouTube video or last part (after www.youtube.com\/v\/ and before the first question mark)","filter":"url","default":""},"width":{"required":false,"name":"Width","description":"Width in pixels","filter":"digits","default":425},"height":{"required":false,"name":"Height","description":"Height in pixels","filter":"digits","default":350},"quality":{"required":false,"name":"Quality","description":"Quality of the video. Default is high.","default":"high","filter":"alpha","options":[{"text":"","value":""},{"text":"High","value":"high"},{"text":"Medium","value":"medium"},{"text":"Low","value":"low"}],"advanced":true},"allowFullScreen":{"required":false,"name":"Allow Fullscreen","description":"Enlarge video to full screen size","default":"","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}],"advanced":true},"related":{"required":false,"name":"Related","description":"Show related videos (shown by default)","since":6.1,"default":"","filter":"alpha","options":[{"text":"","value":""},{"text":"Yes","value":"y"},{"text":"No","value":"n"}],"advanced":true},"background":{"required":false,"name":"Background","description":"Toolbar background color. Use an HTML color code. Example: ffffff","accepted":"HTML color code, e.g. ffffff","since":6.1,"filter":"striptags","default":"","advanced":true},"border":{"required":false,"name":"Borders","description":"Toolbar border colors. Use an HTML color code. Example: ffffff","accepted":"HTML color code, e.g. ffffff","since":6.1,"filter":"striptags","default":"","advanced":true}}};
tiki_plugins.box1 = {"name":"Box1","description":"A box with a light green background","prefs":["wikiplugin_box1"],"filter":"xss","inline":false,"params":{"title":{"required":false,"safe":false,"name":"Box1","description":"The title","filter":"xss"}},"body":"Box1"};
tiki_plugins.box2 = {"name":"Box2","description":"A box with a yellow background","prefs":["wikiplugin_box2"],"filter":"xss","inline":false,"params":{"title":{"required":false,"safe":false,"name":"Box2","description":"The title","filter":"xss"}},"body":"Box2"};
tiki_plugins.thumb = {"name":"Thumbnail","documentation":"PluginThumb","description":"Displays a thumbnail of an image that enlarges upon mouseover or links to a target","prefs":null,"params":{"file":{"required":false,"name":"File ID","description":"File ID from the file gallery.","filter":"digits"},"id":{"required":false,"name":"Image ID","description":"Image ID from the image gallery.","filter":"digits"},"image":{"required":false,"name":"Image URL","description":"URL to the image.","filter":"url"},"max":{"required":false,"name":"Maximum Size","description":"Maximum width or height for the image.","filter":"int"},"float":{"required":false,"name":"Alignment","description":"Set alignment as left, right or none.","filter":"alpha","options":{"none":{"text":"None"},"left":{"text":"Left"},"right":{"text":"Right"}}},"url":{"required":false,"name":"Link Target","description":"Link target of the image.","filter":"url"}}};
tiki_plugins.image = {"name":"Image","documentation":"PluginImage","description":"Display images","params":{"fileId":{"required":false,"name":"File ID","description":"Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required."},"id":{"required":false,"name":"Image ID","description":"Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required."},"src":{"required":false,"name":"Image source","description":"Full URL to the image to display. \"fileId\", \"id\" or \"src\" required.","filter":"url"},"scalesize":{"required":false,"name":"Maximum size","description":"Maximum width or height for the image in pixels."},"height":{"required":false,"name":"Image height","description":"Height in pixels.","filter":"int"},"width":{"required":false,"name":"Image width","description":"Width in pixels.","filter":"int"},"link":{"required":false,"name":"Link","description":"For making the image a hyperlink. Enter a url to the page the image should link to.","filter":"url"},"rel":{"required":false,"name":"Link relation","description":"Link relation attribute to add to the link."},"title":{"required":false,"name":"Link title","description":"Link title that appears upon mouseover."},"alt":{"required":false,"name":"Alternate text","description":"Alternate text that displays image doesn't load."},"align":{"required":false,"name":"Align image block","description":"Enter right, left or center to align the box containing the image.","options":{"left":{"text":"Left"},"right":{"text":"Right"},"center":{"text":"Center"}}},"block":{"required":false,"name":"Wrapping control","description":"Whether to block items from wrapping next to image from the top or bottom. (top,bottom,both,none)","options":{"0":{"text":"None"},"top":{"text":"Top"},"bottom":{"text":"Bottom"},"both":{"text":"Both"}}},"desc":{"required":false,"name":"Description","description":"Image caption"},"usemap":{"required":false,"name":"Image map","description":"Name of the image map to use."},"class":{"required":false,"name":"CSS class","description":"CSS class to apply to the image."},"style":{"required":false,"name":"CSS syle","description":"CSS styling to apply."},"border":{"required":false,"name":"Border options","description":"Border configuration for image block."},"descoptions":{"required":false,"name":"Caption style","description":"Styling of image description. Use CSS syntax to override default setting."},"default":{"required":false,"name":"Default configuration","description":"Default configuration definitions (usually set by admin)."},"mandatory":{"required":false,"name":"Mandatory configuration","description":"Mandatory configuration definitions (usually set by admin)."}}};
tiki_plugins.picture = {"name":"Picture","description":"Display uploaded pictures","params":{"file":{"required":true,"name":"File path","description":"File name or path of the image."}}};
